{
/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
                       T h e   N E Z u l a t o r
                                V.0037
\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
                 http://members.tripod.com/~nezulator
                            C R E D I T S

                  Speed-ups / Add-ons / Commenting by
                             Troy McLeod

                             Originally by
                              Jon Olick
                        (zelex@geocities.com)

                          T H A N K   Y O U ' s

    to Clockwork for all his help, support, and for the compatability list.
               to SteveTylr for helpin me when I needed it.
                to FrodoDead for helpin me and support.
                   to YOSHi for his awsome NES docs.
             to zsKnight for all his help gettin out the bugs.
               And all you other people I forgot to mention.
\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
}
program NEZ37;

{$M 32768,0,256000}
{$F+,G+}

USES CRT, Dos, General, mcga, Graphics;

PROCEDURE Error(S : String);                                     Forward;
PROCEDURE ShutDown;                                              Forward;
PROCEDURE InitGraphics;                                          Forward;
PROCEDURE SetMode(mode:byte);                                    Forward;
PROCEDURE Mode_256x256;                                          Forward;
PROCEDURE Mode_256x240;                                          Forward;
PROCEDURE DoScreenMode(ScreenMode : Byte);                       Forward;
PROCEDURE Keyboard;                                              Forward;
PROCEDURE Joystick;                                              Forward;
FUNCTION  GetMem(Addr : Word) : Byte;                            Forward;
PROCEDURE PutMemory(Addr : word; Byt : byte);                    Forward;
PROCEDURE DoExit;                                                Forward;
PROCEDURE DoMenu(Where : Word);                                  Forward;
FUNCTION  LoadNES(FileName : String; ShowData : Boolean) : Byte; Forward;

{define DEBUG}
{define DEBUG2}
{define DEBUG3}

TYPE
 Paltyp = array[0..63, 1..3] of byte;
 MenuItemRec = record
   Visible : Boolean;
   Name    : String[20];
 END;
 BoxPosition = record
   X       : Integer;
   Y       : Integer;
 END;

CONST
     VER = '3.7';
 CurrentMode : Byte = $03;

     F_CARRY = $01; { Carry Flag       0=Borrow     1=No Borrow             }
     F_ZERO  = $02; { Zero Flag        0=Not Zero   1=Zero                  }
     F_INT   = $04; { Interrupt Flag   0=Set        1=Disabled              }
     F_DEC   = $08; { Decimal Mode     0=Hex        1=BCD ($00-$99 = 00-99) }
     F_BREAK = $10; { Break Flag       0=Normal     1=BRK Executed          }
     F_RSRVD = $20; { Reserved         0=Never      1=Always                }
     F_OVER  = $40; { Overflow Flag    0=Normal     1=Result Too Large      }
     F_SIGN  = $80; { Sign Flag        0=Positive   1=Negative              }

     N_CARRY = $FE; { NOT Carry Flag       }
     N_ZERO  = $FD; { NOT Zero Flag        }
     N_INT   = $FB; { NOT Interrupt Flag   }
     N_DEC   = $F7; { NOT Decimal Mode     }
     N_BREAK = $EF; { NOT Break Flag       }
     N_OVER  = $BF; { NOT Overflow Flag    }
     N_SIGN  = $7F; { NOT Sign Flag        }

 A_Key       : Word = $2C5A;   {X}
 B_Key       : Word = $2D58;   {Z}
 Select_Key  : Word = $3920;   {Space}
 Start_Key   : Word = $1C0D;   {Enter}
 Up_Key      : Word = $48E0;
 Down_Key    : Word = $50E0;
 Left_Key    : Word = $4BE0;
 Right_Key   : Word = $4DE0;
 ROMDir      : String = 'ROMS\';
 (******* Mapper Types *******)
 NONE     = $00;
 CNROM    = $03;
 (***** End Mapper Types *****)
 StackOffset = $100;
 CPUcPVB     = 26500; {18000}
 MouseHotSpot : Array[0..1] Of Byte = (0,0);
 MouseCur : Array[0..11,0..11] Of Byte =
  ( ($00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$0F,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$0F,$0F,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$0F,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$00,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($00,$FF,$00,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($FF,$FF,$00,$0F,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($FF,$FF,$FF,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF),
    ($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF));
 Pal : Paltyp =
  (
{Sui's Upgraded Pallete}
{    ($75,$75,$75),($27,$1B,$8F),($00,$00,$AB),($47,$00,$9F),
    ($8F,$00,$77),($AB,$00,$13),($A7,$00,$00),($7F,$B,$00),
    ($43,$2F,$00),($00,$47,$00),($00,$51,$00),($00,$3F,$17),
    ($1B,$3F,$5F),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($BC,$BC,$BC),($00,$73,$EF),($23,$3B,$EF),($83,$00,$F3),
    ($BF,$00,$BF),($E7,$00,$5B),($DB,$2B,$00),($CB,$4F,$F),
    ($8B,$73,$00),($00,$97,$00),($00,$AB,$00),($00,$98,$3B),
    ($00,$83,$8B),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($FF,$FF,$FF),($3F,$5B,$FF),($50,$97,$FF),($A7,$8B,$FD),
    ($F7,$7B,$FF),($FF,$77,$B7),($FF,$9B,$3B),($F3,$8F,$3F),
    ($83,$D3,$13),($4F,$DF,$4B),($58,$F8,$98),($00,$EB,$DB),
    ($00,$00,$00),($00,$00,$00),($00,$00,$00),($FF,$FF,$FF),
    ($AB,$E7,$FF),($C7,$D7,$FF),($D7,$CB,$FF),($FF,$C7,$FF),
    ($FF,$C7,$DB),($FF,$BF,$B3),($FF,$DB,$AB),($FF,$E7,$A3),
    ($E3,$FF,$A3),($AB,$F3,$BF),($B3,$FF,$CF),($9F,$FF,$F3),
    ($00,$00,$00),($00,$00,$00),($00,$00,$00),($00,$00,$00));}
{My upgraded Loopy's Pallete}
{    (29,29,29),(10,07,36),(00,00,43),(18,00,40),
    (36,00,30),(43,00,05),(42,00,00),(32,03,00),
    (17,12,00),(00,18,00),(00,20,00),(00,16,06),
    (07,16,24),(00,00,00),(00,00,00),(00,00,00),
    (47,47,47),(00,29,60),(09,15,60),(33,00,61),
    (48,00,48),(58,00,23),(55,11,00),(51,20,04),
    (35,29,00),(00,38,00),(00,43,00),(00,37,15),
    (00,33,35),(00,00,00),(00,00,00),(00,00,00),
    (64,64,64),(16,48,64),(24,38,64),(42,35,63),
    (62,31,64),(64,30,46),(64,30,25),(64,39,15),
    (61,48,16),(33,53,05),(20,56,19),(22,62,38),
    (00,59,55),(00,00,00),(00,00,00),(00,00,00),
    (64,64,64),(43,58,64),(50,54,64),(54,51,64),
    (64,50,64),(64,50,55),(64,48,45),(64,55,43),
    (64,58,41),(57,64,41),(43,61,48),(45,64,52),
    (40,64,61),(00,00,00),(00,00,00),(00,00,00));}
{Adjusted Pasofami Palette}
{    (148,148,148),( 20, 84,244),( 20, 52,244),( 84, 52,244),
    (244, 20,244),(244, 20, 84),(244, 20,  4),(212, 20,  4),
    (180, 84,  4),(  4,116,  4),(  4,148,  4),(  4,116, 20),
    (  4, 84, 84),(  0,  0,  0),(  0,  0,  0),(  0,  0,  0),

    (180,180,180),(  4,116,244),(  4, 84,244),( 84, 84,244),
    (244, 52,244),(244, 52, 84),(244, 52,  4),(244, 84,  4),
    (148,148,  4),(  4,180,  4),(  4,212,  4),( 20,212, 84),
    (  4,180,244),(  0,  0,  0),(  0,  0,  0),(  0,  0,  0),

    (212,212,212),(  4,148,244),(116,116,244),(148,116,244),
    (244,116,244),(244, 84,148),(244,116, 84),(244,180,  4),
    (212,212,  4),(180,244, 20),(116,244, 52),( 84,244,148),
    ( 52,212,244),(116,116,116),(  0,  0,  0),(  0,  0,  0),

    (244,244,244),(116,180,244),(180,180,244),(212,180,244),
    (244,148,244),(244,148,180),(244,180,116),(244,180, 52),
    (244,180, 84),(212,244,116),(180,244,180),(180,244,212),
    (148,212,244),(244,212,244),(  0,  0,  0),(  0,  0,  0));}
{Alex Krasivsky's Palette}
    ($68,$68,$68),($00,$40,$80),($00,$00,$80),($40,$00,$80),
    ($80,$00,$80),($80,$00,$40),($80,$00,$00),($55,$00,$00),
    ($40,$40,$00),($33,$50,$00),($00,$50,$00),($00,$50,$00),
    ($00,$40,$40),($00,$00,$00),($00,$00,$00),($00,$00,$00),

    ($98,$98,$98),($00,$80,$C0),($40,$40,$C0),($80,$00,$C0),
    ($C0,$00,$C0),($C0,$00,$80),($C0,$20,$20),($C0,$40,$00),
    ($80,$80,$00),($55,$80,$00),($00,$80,$00),($33,$80,$33),
    ($00,$80,$80),($00,$00,$00),($00,$00,$00),($00,$00,$00),

    ($D0,$D0,$D0),($40,$C0,$FF),($80,$80,$FF),($C0,$40,$FF),
    ($FF,$00,$FF),($FF,$40,$C0),($FF,$50,$50),($FF,$80,$40),
    ($C0,$C0,$00),($80,$C0,$00),($00,$C0,$00),($55,$C0,$55),
    ($00,$C0,$C0),($33,$33,$33),($00,$00,$00),($00,$00,$00),

    ($FF,$FF,$FF),($80,$FF,$FF),($C0,$C0,$FF),($FF,$80,$FF),
    ($FF,$40,$FF),($FF,$80,$FF),($FF,$80,$80),($FF,$C0,$80),
    ($FF,$FF,$40),($C0,$FF,$40),($40,$FF,$40),($AA,$FF,$AA),
    ($40,$FF,$FF),($99,$99,$99),($00,$00,$00),($00,$00,$00));

  LoadStart : BoxPosition = (X:10;Y:10);

  LBreak = '-------------------';
  MenuLength : Array[0..4] Of Byte = (4,1,0,0,1);
  MenuItems : Array[0..4,0..11] Of MenuItemRec =
   (((Visible:True;  Name:'File'),    (Visible:True;  Name:'Load'),
     (Visible:False; Name:LBreak),    (Visible:True;  Name:'Exit (Alt-X)'),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:'')),

    ((Visible:True;  Name:'CPU'),     (Visible:True;  Name:'Reset'),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:'')),

    ((Visible:True;  Name:'Graphics'),(Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:'')),

    ((Visible:True;  Name:'Sound'),   (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:'')),

    ((Visible:True;  Name:'Misc'),    (Visible:True;  Name:'Input Config'),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:''),
     (Visible:False; Name:''),        (Visible:False; Name:'')));


TYPE
 a_reg = byte;
 x_reg = byte;
 y_reg = byte;
 flag_reg = byte;
 s_reg = integer;
 pc_reg = word;
 Image = array[1..$FFFF] of byte;    { Isn't this 1 byte small ? }
 MenuR = record
    MainView : Boolean;
    Show     : Byte;
 End;

VAR
 NewX : Byte;
 Count : LongInt;

{CPU}
 RA : a_reg;            { Accumulator     }
 RX : x_reg;            { Index X         }
 RY : y_reg;            { Index Y         }
 RF : flag_reg;         { Flags           }
 RS : s_reg;            { Stack Pointer   }{ ** Can't Be Named SP ** }
 PC : pc_reg;           { Program Counter }
 AdrMode : array[0..255] of PROCEDURE;
 Instruction : array[0..255] of PROCEDURE;
 Ticks : array[0..256] of integer;
 OpCode : Byte;
 ClockTicks : integer;
 TimerTicks : Integer;
 SavePC : word;
 Value : byte;
 Value2 : byte;
 Sum, saveflags : integer;
 help : word;
 helper : word;
 CPUMem : ^Image;
 addrmask : word;
 chr : char;
 Scart : boolean;
 T : Text;
 F : File;
{Config File Stuff}
 JoyOF : byte;
 ScreenMode : byte;
 FrameSkip,
 FramesSkip : byte;
{Graphics Pages}
 Page2,
 Page1,
 Page0        : word;
 Mapper       : Byte;
 VertMirror   : Boolean;
{Menu}
 Counter : Word;
 Menu : MenuR;
 MouseInstalled : Boolean;
 CurrentPos : Byte;
 NewROM : Boolean;
{Keyboard}
 Key      : Word;
{Joy Stick}
 JoyWrite : byte;                           { Is Joystick being written to? }
 joy : byte;                         { Contains Joystick Button Info, etc.. }
 JoyCounter,                                  { Current Joystick Read (0-7) }
 Jxc,                                     { Center Of Joystick X-Coordinate }
 Jyc,                                     { Center Of Joystick Y-Coordinate }
 JoyX,                                      { Current Joystick X-Coordinate }
 JoyY : integer;                            { Current Joystick Y-Coordinate }
{PPU Variables}
{ ATable : array[0..37,0..37] of byte;}
 VTable : array[0..37,0..37] of byte;
 VBlank : boolean;
{ VBlank_Clocks : shortint;}
 VBlank_Clocks : Word;
 Exec_NMI_VBlank : boolean;
 Exec_NMI_Sprite_Hit : boolean;
 Sprite_Size : byte;
 Scr_Pat_Tab_Adr : word;
 Spr_Pat_Tab_Adr : word;
 PPU_Adr_RW_Inc : byte;
 Name_Table_Select : word;
 BGcolor : byte;
 OldBGColor : Byte;
 Spr_Disp : boolean;
 Scr_Disp : boolean;
 Spr_Clip : boolean;
 Img_Clip : boolean;
 Clr_Disp : boolean;
 PPUMem : Array[0..$4000] of byte;  {16K}
 PPUptr : word;
 PPUADR : boolean;
 PPUADDR : word;
 SprRam : array[0..$100] of byte;
 CPUticks : longint;
 CPUinstr : longint;
 Scroll : word;
 MapperType : Byte;
{ gc : char;}
 str : string;
 OrigDir : String;

PROCEDURE Error(S : String);
Begin
     If CurrentMode <> $03 Then SetMode($03);
     WriteLn(S);
     Halt;
End;

PROCEDURE ShutDown;
Begin
 Writeln('Deallocating memory...');
 Dispose(CPUMem);
 FreeAlloc(Page1);
 {$ifdef DEBUG}
  Close(T);
 {$endif}
 Writeln('Shutting down...');
End;

PROCEDURE InitGraphics;
VAR
 v1 : word;
Begin
 Page0 := $A000;
 v1    := 5000;
 Page1 := Alloc(v1);
 Page2 := Alloc(v1);
 If Page1 = $FFFF Then Error('Not enough memory for virtual screen!')
 ELSE
 If Page2 = $FFFF Then Error('Not enough memory for virtual screen!')
 ELSE
 Writeln(' -Allocated Memory for Virtual Screen...');
End;

PROCEDURE WRITEOpCodeF;
Begin
 Case OpCode Of
  $00: write(T,'BRK ');
  $01,$05,$09,$0D,$11,$12,$15,$19,$1D: write(T,'ORA ');
  $02,$03,$07,$0B,$0F,$13,$17,$1B,$1F,$22,$23,$27,$2B,$2F,$33,$37,$3B,$3F,
  $42,$43,$44,$47,$4B,$4F,$53,$54,$57,$5B,$5C,$5F,$62,$63,$67,$6B,$6F,$73,
  $77,$7B,$7F,$82,$83,$87,$8B,$8F,$93,$97,$9B,$9F,$A3,$A7,$AB,$AF,$B3,$B7,
  $BB,$BF,$C2,$C3,$C7,$CB,$CF,$D3,$D4,$D7,$DB,$DC,$DF,$E2,$E3,$E7,$EA,$EB,
  $EF,$F3,$F4,$F7,$FB,$FC,$FF: write(T,'NOP ');
  $04,$0C: write(T,'TSB ');
  $06,$0E,$16,$1E: write(T,'ASL ');
  $08: write(T,'PHP ');
  $0A: write(T,'ASLA ');
  $10: write(T,'BPL ');
  $14,$1C: write(T,'TRB ');
  $18: write(T,'CLC ');
  $1A: write(T,'INA ');
  $20: write(T,'JSR ');
  $21,$25,$29,$2D,$31,$32,$35,$39,$3D: write(T,'AND ');
  $24,$2C,$34,$3C,$89: write(T,'BIT ');
  $26,$2E,$36,$3E: write(T,'ROL ');
  $28: write(T,'PLP ');
  $2A: write(T,'ROLA');
  $30: write(T,'BMI ');
  $38: write(T,'SEC ');
  $3A: write(T,'DEA ');
  $40: write(T,'RTI ');
  $41,$45,$49,$4D,$51,$52,$55,$59,$5D: write(T,'EOR ');
  $46,$4E,$56,$5E: write(T,'LSR ');
  $48: write(T,'PHA ');
  $4A: write(T,'LSRA');
  $4C,$6C,$7C: write(T,'JMP ');
  $50: write(T,'BVC ');
  $58: write(T,'CLI ');
  $5A: write(T,'PHY ');
  $60: write(T,'RTS ');
  $61,$65,$69,$6D,$71,$72,$75,$79,$7D: write(T,'ADC ');
  $64,$74,$9C,$9E: write(T,'STZ ');
  $66,$6E,$76,$7E: write(T,'ROR ');
  $68: write(T,'PLA ');
  $6A: write(T,'RORA');
  $70: write(T,'BVS ');
  $78: write(T,'SEI ');
  $7A: write(T,'PLY ');
  $80: write(T,'BRA ');
  $81,$85,$8D,$91,$92,$95,$99,$9D: write(T,'STA ');
  $84,$8C,$94: write(T,'STY ');
  $86,$8E,$96: write(T,'STX ');
  $88: write(T,'DEY ');
  $8A: write(T,'TXA ');
  $90: write(T,'BCC ');
  $98: write(T,'TYA ');
  $9A: write(T,'TXS ');
  $A0,$A4,$AC,$B4,$BC: write(T,'LDY ');
  $A1,$A5,$A9,$AD,$B1,$B2,$B5,$B9,$BD: write(T,'LDA ');
  $A2,$A6,$AE,$B6,$BE: write(T,'LDX ');
  $A8: write(T,'TAY ');
  $AA: write(T,'TAX ');
  $B0: write(T,'BCS ');
  $B8: write(T,'CLV ');
  $BA: write(T,'TSX ');
  $C0,$C4,$CC: write(T,'CPY ');
  $C1,$C5,$C9,$CD,$D1,$D2,$D5,$D9,$DD: write(T,'CMP ');
  $C6,$CE,$D6,$DE: write(T,'DEC ');
  $C8: write(T,'INY ');
  $CA: write(T,'DEX ');
  $D0: write(T,'BNE ');
  $D8: write(T,'CLD ');
  $DA: write(T,'PHX ');
  $E0,$E4,$EC: write(T,'CPX ');
  $E1,$E5,$E9,$ED,$F1,$F2,$F5,$F9,$FD: write(T,'SBC ');
  $E6,$EE,$F6,$FE: write(T,'INC ');
  $E8: write(T,'INX ');
  $F0: write(T,'BEQ ');
  $F8: write(T,'SED ');
  $FA: write(T,'PLX ');
 End;
End;

PROCEDURE SetMode(mode:byte); assembler;
ASM
 mov ah, 0
 mov al, mode
 mov CurrentMode, al
 int $10
End;

{PROCEDURE pset(x,y:integer;color:byte);assembler;
asm
 mov ax, y
 mov bx, ax
 shl ax, 8
 shl bx, 6
 add ax, bx
 add ax, x
 mov di, ax
 mov ax, $A000
 mov es, ax
 mov al, color
 mov es:[di], al
End;}

PROCEDURE Mode_256x256;
Begin
  Port [$3D4]:=$11; Port[$3D5]:=Port[$3D5] AND $7F;  {Turn off Write Protect}
  Port [$3C2]:=$E3;                              {perfect pixel aspect ratio}
  PortW[$3D4] := $5F00;              {+5}       {# Character Clocks/scanline}
  PortW[$3D4] := $3F01;                           {End of Horizontal Display}
  PortW[$3D4] := $4002;                           {Start Horizontal Blanking}
  PortW[$3D4] := $8203;                             {End Horizontal Blanking}
  PortW[$3D4] := $4A04;
  PortW[$3D4] := $9A05;
  PortW[$3D4] := $2306;
  PortW[$3D4] := $B207;
  PortW[$3D4] := $0008;
  PortW[$3D4] := $6109;
  PortW[$3D4] := $0A10;
  PortW[$3D4] := $AC11;                               {Turn On Write Protect}
  PortW[$3D4] := $FF12;
  PortW[$3D4] := $2013;
  PortW[$3D4] := $4014;
  PortW[$3D4] := $0715;
  PortW[$3D4] := $1A16;
  PortW[$3D4] := $E317;
  PortW[$3C4] := $0101;
  PortW[$3CE] := $4005;
  PortW[$3CE] := $0506;
(**** This causes older video cards to just display a black screen !?!? ****)
{  PortW[$3C0] := $4110;                        { $40=Pixel Width so... PW=1}
(***************************************************************************)
{  Port[$3C4]:=$03; Port[$3C5]:=$00;
  Port[$3C4]:=$04; Port[$3C5]:=$0E;}
End;

PROCEDURE Mode_256x240;
Begin
  Port [$3D4]:=$11; Port[$3D5]:=Port[$3D5] AND $7F;  {Turn off Write Protect}
  Port [$3C2]:=$E3;                              {perfect pixel aspect ratio}
  PortW[$3D4] := $5F00;              {+5}       {# Character Clocks/scanline}
  PortW[$3D4] := $3F01;                           {End of Horizontal Display}
  PortW[$3D4] := $4002;                           {Start Horizontal Blanking}
  PortW[$3D4] := $8203;                             {End Horizontal Blanking}
  PortW[$3D4] := $4E04;
  PortW[$3D4] := $9605;
  PortW[$3D4] := $0D06;
  PortW[$3D4] := $3E07;
  PortW[$3D4] := $0008;
  PortW[$3D4] := $4109;
  PortW[$3D4] := $EA10;
  PortW[$3D4] := $AC11;                               {Turn On Write Protect}
  PortW[$3D4] := $DF12;
  PortW[$3D4] := $2013;
  PortW[$3D4] := $4014;
  PortW[$3D4] := $E715;
  PortW[$3D4] := $0616;
  PortW[$3D4] := $E317;
  PortW[$3C4] := $0101;
  PortW[$3CE] := $4005;
  PortW[$3CE] := $0506;
(**** This causes older video cards to just display a black screen !?!? ****)
{  PortW[$3C0] := $4110;                         { $40=Pixel Width so... PW=1}
End;

PROCEDURE DoScreenMode(ScreenMode : Byte);
Begin
 case ScreenMode of
  0: Begin
          SetMode($13);
          Mode_256x256;
          ScrWidth := 256;
          ScrHeight := 256;
     End;
  1: Begin
          SetMode($13);
          ScrWidth  := 320;
          ScrHeight := 200;
      End;
  2: Begin
          SetMode($13);
          Mode_256x240;
          ScrWidth  := 256;
          ScrHeight := 240;
     End;
  ELSE
     Begin
          ScreenMode := 0;
          SetMode($13);
          Mode_256x256;
     End;
 End;
 ASM
    Mov Ax, $0007
    Mov Cx, 0
    Mov Dx, ScrWidth
    Dec Dx
    Int $33
    Mov Ax, $0008
    Mov Cx, 0
    Mov Dx, ScrHeight
    Dec Dx
    Int $33
 End;
End;

PROCEDURE Keyboard;
Begin
     Case JoyCounter Of
       0 : CPUMem^[$4016] := $40 + Byte(Key = B_Key);       { B }
       1 : CPUMem^[$4016] := $40 + Byte(Key = A_Key);       { A }
       2 : CPUMem^[$4016] := $40 + Byte(Key = Select_Key);  { Select }
       3 : CPUMem^[$4016] := $40 + Byte(Key = Start_Key);   { Start }
       4 : CPUMem^[$4016] := $40 + Byte(Key = Up_Key);
       5 : CPUMem^[$4016] := $40 + Byte(Key = Down_Key);
       6 : CPUMem^[$4016] := $40 + Byte(Key = Left_Key);
       7 : Begin
                CPUMem^[$4016] := $40 + Byte(Key = Right_Key);
                Key := $FFFF;
           End;
     End;
     Inc(JoyCounter);
     JoyCounter := JoyCounter AND 7;
     RA := CPUMem^[$4016];
End;

PROCEDURE Joystick;
Begin
     Case JoyCounter Of
       0 : Begin
             ASM                { We only need to read the PC     }
                Mov JoyX, 0
                Mov JoyY, 0
                Mov Dx, $201    { joystick once for each of these }
                Xor Al, Al
{                Cmp JoyWrite, 1
                Jl @GetData}

                Out Dx, Al                 { Send a 0 to Joystick }
               @DummyLoop:               { Needed to Power up the }
                In  Al, Dx               { joystick. Otherwise it }
                Mov Joy, Al
                And Al, $03              { returns inconsistant   }
                Jnz @DummyLoop           { information.           }
{                Jmp @End}

               @GetData:
                Out Dx, Al                 { Send a 0 to Joystick }
               @Again:
                In  Al, Dx                        { Read Joystick }
                Mov Bl, Al                           { Copy Value }
                Mov Cl, Al
                And Bl, $01         { Is Horiz Movment > 0 still? }
                Jz @CheckedJoyX
                Inc JoyX                 { If So, Then Inc(JoyX); }
               @CheckedJoyX:
                And Cl, $02          { Is Vert Movment > 0 still? }
                Jz @CheckedJoyY
                Inc JoyY                 { If So, Then Inc(JoyY); }
               @CheckedJoyY:
                And Al, $03  { Are both directions done counting? }
                Jnz @Again
                Mov Al, Al
               @End:
             END;
                CPUMem^[$4016] := $40 + ((Joy AND $40) shr 6) Xor 1; { B }
           End;
       1 : CPUMem^[$4016] := $40 + ((Joy AND $10) shr 4) Xor 1; { A }
       2 : CPUMem^[$4016] := $40 + ((Joy AND $80) shr 7) Xor 1; { Select }
       3 : CPUMem^[$4016] := $40 + ((Joy AND $20) shr 5) Xor 1; { Start }
       4 : CPUMem^[$4016] := $40 + Byte(JoyY < 50);
       5 : CPUMem^[$4016] := $40 + Byte(JoyY > Jyc+150);
       6 : CPUMem^[$4016] := $40 + Byte(JoyX < 50);
       7 : Begin
                CPUMem^[$4016] := $40 + Byte(JoyX > Jxc+150);
                Key := $FFFF;
           End;
     End;
     Inc(JoyCounter);
     JoyCounter := JoyCounter AND 7;
     RA := CPUMem^[$4016];
End;


FUNCTION GetMem(Addr : Word) : Byte;
Begin
     If Addr = $4016 Then
        Begin
             ASM
                Cmp JoyOf, 1
                Jne @Keyboard
                Call JoyStick
                Jmp @End
               @Keyboard:
                Call Keyboard
               @End:
             END;
        End;
     GetMem := CPUMem^[Addr];
End;

PROCEDURE PutMemory(Addr : word; Byt : byte);
VAR X : Byte;
Begin
     Case Addr Of
     $0000..
     $1FFF : Begin
                  Addr := (Addr AND $7FF);     {  Writes to First 2K }
                  CPUMem^[Addr+$0000] := Byt;  { of Internal RAM are }
                  CPUMem^[Addr+$0800] := Byt;  { Mirrored.           }
                  CPUMem^[Addr+$1000] := Byt;
                  CPUMem^[Addr+$1800] := Byt;
                  Exit;
             End;
{    $2000 : PPU Control Register #1 - Taken care of as default }
{ ****** However, should be updated when screen scrolls ! ****** }
{    $2001 : PPU Control Register #2 - Taken care of as default }
{    $2002 : PPU Status Register - Read Only }
{SPRIO}
{    $2003 : Sprite Memory Address - Taken care of as default }
     $2004 : Begin
                  SprRAM[CPUMem^[$2003]] := Byt;
                  Inc(CPUMem^[$2003]);
                  Exit;
             End;
     $2005 : Scroll := (Scroll shl 8) + Byt;
     $2006 : Begin
                  PPUADDR := ((PPUADDR shl 8) + Byt) AND $3FFF;
 {$ifdef DEBUG2}
   Write(T,'VRAM Setadr-');
   WRITEOpCodeF;
   Writeln(T,'->',Hex(PPUADDR),' - ',Copy(Hex(CPUMem^[addr]),2,4));
 {$endif}
                  Exit;
             End;
     $2007 : Begin
{                 If PPUADR = False Then
                     If (PPUADDR > $3F00) and (PPUADDR < $3F21) Then
                     Begin
                          PPUMem[$3F00+(PPUADDR and $F)] := CPUMem^[Addr];
                          PPUMem[$3F10+(PPUADDR and $F)] := CPUMem^[Addr];
                     End;}
                  If (PPUADDR = $3F00) Then
                  Begin
                       PPUMem[$3F00] := Byt;
                       PPUMem[$3F10] := Byt;
                  End
                  ELSE If (PPUADDR >= $2000) AND (PPUADDR < $3000) Then
                  Begin
                       If VertMirror Then
                       Begin
                            PPUMem[PPUADDR AND $27FF] := Byt;
                            PPUMem[(PPUADDR AND $27FF)+$800] := Byt;
                       End
                       ELSE
                       Begin
                            PPUMem[PPUADDR AND $2BFF] := Byt;
                            PPUMem[(PPUADDR AND $2BFF)+$400] := Byt;
                       End;
                  End
                  ELSE PPUMem[PPUADDR] := Byt;
 {$ifdef DEBUG2}
   Write(T,'VRAM W-');
   WRITEOpCodeF;
   Writeln(T,'->',Hex(PPUADDR),'=',Copy(Hex(CPUMem^[addr]),2,4));
 {$endif}
                  PPUADDR := (PPUADDR + PPU_adr_RW_inc) AND $3FFF;
                  Exit;
             End;
     $4000..
     $4013 : Begin
                  {SOUND STUFF!!}
{                  sound(byt);
                   delay(2)}
{                  For X := 0 to 7 Do
                      Mem[$A000:124+X] := (Byt AND (1 shl X)) shr x + 20;
                  Delay(100);}
             End;
{Sprite DMA}
     $4014 : Begin
{                  Write(F, Hex(CPUMem^[Addr]  shl 8),'-');
                  For Temp := 0 to 255 Do
                      Write(F, Char(CPUMem^[(CPUMem^[Addr] shl 8)+Temp]));
                  WriteLn(F);}
                  Move(CPUMem^[Byt shl 8],SprRAM[0],256);
                  Exit;
             End;
     $4015 : Begin
                  {SOUND Channel Switches}
             End;
{     $4016 : Joystick #1 Data Line }
{     $4017 : Joystick #2 Data Line }
(***** If Nothing else, just set memory *****)
             ELSE
             CPUMem^[Addr] := Byt;
     End;
End;

{///////////////////////////////////////////////////////////////////////////
                             Flag Set/Unsets
 \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}


PROCEDURE SetCarry(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_CARRY/       { Or  Al, F_CARRY                 }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_CARRY/       { And Al, N_CARRY                 }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetZero(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_ZERO/        { Or  Al, F_ZERO                  }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_ZERO/        { And Al, N_ZERO                  }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetInt(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_INT/         { Or  Al, F_INT                   }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_INT/         { And Al, N_INT                   }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetDec(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_DEC/         { Or  Al, F_DEC                   }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_DEC/         { And Al, N_DEC                   }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetBreak(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_BREAK/       { Or  Al, F_BREAK                 }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_BREAK/       { And Al, N_BREAK                 }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetOverFlow(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_OVER/        { Or  Al, F_OVER                  }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_OVER/        { And Al, N_OVER                  }
  $A2/>RF);           { Mov [RF], Al                    }

PROCEDURE SetSign(Option : Boolean); Inline
 ($5B/                { Pop Bx                          }
  $A0/>RF/            { Mov Al, [RF]                    }
  $80/$FB/$01/        { Cmp Bl, True                    }
  $75/$04/            { Jnz $010F                       }
  $0C/<F_SIGN/        { Or  Al, F_SIGN                  }
  $EB/$02/            { Jmp $0111                       }
  $24/<N_SIGN/        { And Al, N_SIGN                  }
  $A2/>RF);           { Mov [RF], Al                    }

{///////////////////////////////////////////////////////////////////////////
                             Addressing Modes
 \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}

{Implied}
PROCEDURE Implied6502; Assembler;
ASM
END;

{Immediate}
PROCEDURE Immediate6502; assembler;
ASM
   mov ax, PC
   mov SavePC, ax
   inc PC
End;

{ABS}
PROCEDURE abs6502; Assembler;
{
     SavePC := CPUMem^[PC] + (CPUMem^[PC+1] shl 8);
     Inc(PC,2);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
{   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[PC])   }
   Mov	Ah, ES:[DI]                  { Ah = Word(CPUMem^[Help+1])}
   Mov	Al, ES:[DI-$01]              { Al = Word(CPUMem^[Help])}
   Mov	SavePC, Ax                   { SavePC = Ax              }
   Add	WORD PTR PC, +$02            { Inc(PC,2);               }
End;

{BRANCH}
PROCEDURE relative6502; Assembler;
(*
Begin
 SavePC := CPUMem^[PC];
 Inc(PC);
 { If Negative Then Subtract 256 }
 If SavePC AND F_SIGN <> 0 Then Dec(SavePC, $100);
 If Hi(SavePC) <> Hi(PC) Then Inc(ClockTicks);
End;
*)
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Xor  Ah, Ah
   Mov  Bx, Ax                       { Bx = Ax                  }
   And  Bx, F_SIGN                   { Bx = Bx AND F_SIGN       }
   Jz  @DoClock                      { If BX = 0 Then Skip      }
   Sub  Ax, $100                     { BX = BX - $100           }
  @DoClock:
   Mov	SavePC, Ax                   { SavePC = Ax              }
   Inc  Word Ptr PC                  { Inc(PC)                  }
   Cmp  Ah, Byte Ptr PC[1]           { Hi(SavePC) = Hi(PC)?     }
   Jz  @End                          { If Yes, Then Skip        }
   Inc  ClockTicks                   { If No, Inc(ClockTicks)   }
  @End:
End;

{(ABS)}
PROCEDURE indirect6502; Assembler;
(*Begin
 help := CPUMem^[PC] + (CPUMem^[PC+1] shl 8);
 SavePC := CPUMem^[help] + (CPUMem^[help+1] shl 8);
 Inc(PC,2);
End;
*)
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Push Di                           { Save Di                  }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[PC])   }
   Mov	Help, Ax                     { Help = Ax                }
   Pop  Di                           { Restore Di               }
   Add	Di, Ax                       { ES:[DI] = CPUMem^[Help]  }
{   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[Help]) }
   Mov	Ah, ES:[DI]                  { Ah = Word(CPUMem^[Help+1])}
   Mov	Al, ES:[DI-$01]              { Al = Word(CPUMem^[Help])}
   Mov	SavePC, Ax                   { Help = Ax                }
   Add	WORD PTR PC, +$02            { Inc(PC,2);               }
End;

{ABS,X}
PROCEDURE absx6502; Assembler;
{
 SavePC := CPUMem^[PC] + (CPUMem^[PC+1] shl 8);
 Inc(PC,2);
 If (Ticks[OpCode]=4) and (X<>0) Then Inc(clockticks);
 Inc(SavePC, X);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[PC])   }
   Add	WORD PTR PC, +$02            { Inc(PC,2);               }
   Mov  Bx, OFFSET Ticks             { DS:[Bx] = Ticks[0]       }
   Mov  Cl, OpCode
   Xor  Ch, Ch
   Add  Bx, Cx                       { Ds:[Bx] = Ticks[OpCode]  }
   Cmp  Word Ptr DS:[Bx], 4          { If Ticks[OpCode] = 4     }
   Jz  @Skip                         { If Not, Skip             }
   Cmp  RX, 0                        { If So, See if X <> 0     }
   Jz  @Skip                         { If Not, Skip             }
   Inc  ClockTicks                   { Inc(ClockTicks);         }
  @Skip:
   Mov  Bl, RX                       { Bl = X                   }
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_X          }
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{ABS,Y}
PROCEDURE absy6502; Assembler;
{
 SavePC := CPUMem^[PC] + (CPUMem^[PC+1] shl 8);
 Inc(PC,2);
 If (Ticks[OpCode]=4) and (Y <> 0) Then Inc(clockticks);
 Inc(SavePC, Y);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[PC])   }
   Add	WORD PTR PC, +$02            { Inc(PC,2);               }
   Mov  Bx, OFFSET Ticks             { DS:[Bx] = Ticks[0]       }
   Mov  Cl, OpCode
   Xor  Ch, Ch
   Add  Bx, Cx                       { DS:[Bx] = Ticks[OpCode]  }
   Cmp  Byte Ptr DS:[Bx], 4          { If Ticks[OpCode] = 4     }
   Jz  @Skip                         { If Not, Skip             }
   Cmp  RY, 0                        { If So, See if Y <> 0     }
   Jz  @Skip                         { If Not, Skip             }
   Inc  ClockTicks                   { Inc(ClockTicks);         }
  @Skip:
   Mov  Bl, RY                       { Bl = Y                   }
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_Y          }
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{Zero Page}
PROCEDURE zp6502; Assembler;
{
 SavePC := CPUMem^[PC];
 Inc(PC);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Xor  Ah, Ah                       { Ah = 0                   }
   Mov	SavePC, Ax                   { SavePC = Ax              }
   Inc  WORD PTR PC                  { Inc(PC);                 }
End;

{Zero Page,X}
PROCEDURE zpx6502; Assembler;
{
 SavePC:=CPUMem^[PC]+X;
 Inc(PC);
 SavePC := SavePC and $ff;
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Xor  Ah, Ah                       { Ah = 0                   }
   Mov  Bl, RX
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_X          }
   Inc  WORD PTR PC                  { Inc(PC);                 }
   And  Ax, $FF                      { Ax = Ax AND $FF          }
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{Zero Page,Y}
PROCEDURE zpy6502; Assembler;
{
 SavePC:=CPUMem^[PC]+Y;
 Inc(PC);
 SavePC := SavePC and $ff;
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Xor  Ah, Ah                       { Ah = 0                   }
   Mov  Bl, RY
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_Y          }
   Inc  WORD PTR PC                  { Inc(PC);                 }
   And  Ax, $FF                      { Ax = Ax AND $FF          }
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{(Zero Page,X)}
PROCEDURE indx6502; Assembler;
{
 Value := CPUMem^[PC]+X;
 Inc(PC);
 SavePC := CPUMem^[Value] + (CPUMem^[Value+1] shl 8);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Push Di
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Xor  Ah, Ah                       { Ah = 0                   }
   Mov  Bl, RX
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_X          }
   Inc  WORD PTR PC                  { Inc(PC);                 }
   Pop  Di                           { ES:[DI] = CPUMem^[0]     }
   Add	Di, Ax                       { ES:[DI] = CPUMem^[Value] }
   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[Value])}
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{(Zero Page),Y}
PROCEDURE indy6502; Assembler;
(*
Begin
 Value := CPUMem^[PC];
 Inc(PC);
 ASM Mov Al, Value END;
 SavePC := CPUMem^[Value] + (CPUMem^[Value+1] shl 8);
 ASM Mov Bx, SavePC END;
 If Ticks[OpCode]=5 Then
  If RY <> 0 Then
   Inc(clockticks);
 Inc(SavePC,RY);
End;*)
ASM
   Les	Di, CPUMem                   { DS:[DI] = CPUMem^[0]     }
   Push Di
   Add	Di, PC                       { DS:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Inc  WORD PTR PC                  { Inc(PC);                 }
   Pop  Di                           { DS:[DI] = CPUMem^[0]     }
   Xor  Ah, Ah
   Add	Di, Ax                       { DS:[DI] = CPUMem^[Value] }
   Mov	Ah, ES:[DI]                  { Ah = Word(CPUMem^[Value+1])}
   Mov	Al, ES:[DI-$01]              { Al = Word(CPUMem^[Value])}
{           This doesn't work! Why??                            }
{   Mov	Ax, WORD Ptr ES:[DI-$01]     { Ax = Word(CPUMem^[Value])}

   Mov  Bx, OFFSET Ticks             { DS:[Bx] = Ticks[0]       }
   Mov  Cl, OpCode
   Xor  Ch, Ch
   Add  Bx, Cx                       { DS:[Bx] = Ticks[OpCode]  }
   Cmp  Byte Ptr ES:[Bx], 5          { If Ticks[OpCode] = 5     }
   Jz  @Skip                         { If Not, Skip             }
   Cmp  RY, 0                        { If So, See if RY <> 0    }
   Jz  @Skip                         { If Not, Skip             }
   Inc  ClockTicks                   { Inc(ClockTicks);         }
  @Skip:
   Mov  Bl, RY                       { Bl = RY                  }
   Xor  Bh, Bh
   Add  Ax, Bx                       { Ax = Ax + Reg_Y          }
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{(ABS,X)}
PROCEDURE indabsx6502; Assembler;
{
 help := CPUMem^[PC] + (CPUMem^[PC+1] shl 8) + X;
 SavePC := CPUMem^[help] + (CPUMem^[help+1] shl 8);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Push Di                           { Save Di                  }
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
{   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[PC])   }
   Mov	Ah, ES:[DI]                  { Ah = Word(CPUMem^[Help+1])}
   Mov	Al, ES:[DI-$01]              { Al = Word(CPUMem^[Help])}
   Mov  Bl, RX                       { Bl = X                   }
   Xor  Bh, Bh                       { Bh = 0                   }
   Add  Ax, Bx                       { Ax = Ax + Bx             }
   Mov	Help, Ax                     { Help = Ax                }
   Pop  Di                           { Restore Di               }
   Add	Di, Ax                       { ES:[DI] = CPUMem^[Help]  }
   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[Help]) }
   Mov	SavePC, Ax                   { Help = Ax                }
End;

{(Zero Page)}
PROCEDURE indzp6502; Assembler;
{
 Value:=CPUMem^[PC];
 Inc(PC);
 SavePC:=CPUMem^[Value] + (CPUMem^[Value+1] shl 8);
}
ASM
   Les	Di, CPUMem                   { ES:[DI] = CPUMem^[0]     }
   Push Di
   Add	Di, PC                       { ES:[DI] = CPUMem^[PC]    }
   Mov	Al, ES:[DI-$01]              { Al = CPUMem^[PC]         }
   Inc  WORD PTR PC                  { Inc(PC);                 }
   Pop  Di                           { ES:[DI] = CPUMem^[0]     }
   Add	Di, Ax                       { ES:[DI] = CPUMem^[Value] }
{   Mov	Ax, ES:[DI-$01]              { Ax = Word(CPUMem^[Value])}
   Mov	Ah, ES:[DI]                  { Ah = Word(CPUMem^[Help+1])}
   Mov	Al, ES:[DI-$01]              { Al = Word(CPUMem^[Help])}
   Mov	SavePC, Ax                   { SavePC = Ax              }
End;

{///////////////////////////////////////////////////////////////////////////
                              Instructions
 \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}

(* Arithmatic Add With Carry *)
PROCEDURE adc6502;
Begin
     AdrMode[OpCode];
     Sum := RA + CPUMem^[SavePC] + (RF AND F_CARRY);

{     If (Sum > $7F) OR (Sum < -$80) Then RF := (RF OR F_OVER)}

  (* Set OverFlow and Carry if Sum > $FF *)
     SetCarry(Sum > $FF);
     SetOverFlow((Sum > $7F) OR (Sum < -$80));

     RA := Sum;
     If (RF AND F_DEC) = F_DEC Then
        Begin
             RF := RF AND N_CARRY;
             If RA AND $0F > $09 Then Inc(RA, $6);
             If RA AND $F0 > $90 Then
                Begin
                     Inc(RA, $60);
                     RF := RF OR F_CARRY;
                End;
        End
     ELSE
        Inc(clockticks);

     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE and6502;
Begin
 ADRMode[OpCode];
 RA := RA AND CPUMem^[SavePC];
 If RA <> 0 Then RF := RF AND N_ZERO ELSE RF := RF OR F_ZERO;
 If RA AND F_SIGN <> 0 Then RF := RF OR F_SIGN ELSE RF := RF and N_SIGN;
End;

(* Arithmatic Shift Left *)
PROCEDURE asl6502;
Begin
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
     SetCarry(Value AND F_SIGN = F_SIGN);
{     RF := (RF AND N_CARRY) OR ((Value shr 7) AND F_CARRY);}
     PutMemory(SavePC, Value shl 1);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

(* Arithmatic Shift Left on Accumulator *)
PROCEDURE asla6502;
Begin
     SetCarry(RA AND F_SIGN = F_SIGN);
{     RF := (RF AND N_CARRY) OR ((RA shr 7) and F_CARRY);}
     RA := RA shl 1;
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE bcc6502;
Begin
 If (RF and F_CARRY) = 0 Then
    Begin
         ADRMode[OpCode];
         Inc(PC, SavePC);
         Inc(clockticks);
    End
 ELSE
    Inc(PC);
End;

PROCEDURE bcs6502;
Begin
 If (RF and F_CARRY) <> 0 Then
    Begin
         AdrMode[OpCode];
         Inc(PC, SavePC);
         Inc(ClockTicks);
    End
 ELSE
    Inc(PC);
End;

PROCEDURE beq6502;
Begin
 If (RF and F_ZERO) <> 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE bit6502;
Begin
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
 (* non-destrucive logical AND between Value and the accumulator
  * and set zero flag *)
     SetZero(Value AND RA = 0);
 (* set negative and overflow flags from Value *)
     RF := (RF AND $3F) OR (Value AND (F_OVER+F_SIGN));
End;

PROCEDURE bmi6502;
Begin
 If (RF and F_SIGN) <> 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE bne6502;
Begin
 If (RF and $2) = 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE bpl6502;
Begin
 If (RF and F_SIGN) = 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE brk6502;
Begin
 Inc(PC);
 PutMemory(StackOffset+RS,BYTE(PC shr 8));
 Dec(RS);
 PutMemory(StackOffset+RS,BYTE(PC and $FF));
 Dec(RS);
 PutMemory(StackOffset+RS,RF);
 Dec(RS);
 RF := RF OR (F_INT + F_BREAK);
 Move(CPUMem^[$FFFE],PC,2);
End;


PROCEDURE bvc6502;
Begin
 If (RF and F_OVER) = 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE bvs6502;
Begin
 If (RF and F_OVER) <> 0 Then Begin
  ADRMode[OpCode];
  Inc(PC, SavePC);
  Inc(clockticks);
 end
 ELSE Begin
  Value := CPUMem^[PC];              (******** Useless ***************)
  Inc(PC);
 End;
End;

PROCEDURE clc6502; Assembler;
ASM And RF, N_CARRY End;

PROCEDURE cld6502; Assembler;
ASM And RF, N_DEC End;

PROCEDURE cli6502; Assembler;
ASM And RF, N_INT End;

PROCEDURE clv6502; Assembler;
ASM And RF, N_OVER End;

PROCEDURE cmp6502;
Begin
     ADRMode[OpCode];
     Sum := RA + $100 - CPUMem^[SavePC];
{     If RA + $100 - CPUMem^[SavePC] > $FF Then
        RF := RF OR F_CARRY ELSE RF := RF AND N_CARRY;}
     SetCarry(Sum > $FF);
     SetZero(Lo(Sum) = 0);
     SetSign(Lo(Sum) AND F_SIGN <> 0);
End;

PROCEDURE cpx6502;
Begin
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
     Sum := RX + $100 - Value;
     SetCarry(Sum > $FF);
     SetZero(Lo(Sum) = 0);
     SetSign(Lo(Sum) AND F_SIGN <> 0);
End;

PROCEDURE cpy6502;
Begin
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
     Sum := RY + $100 - Value;
     SetCarry(Sum > $FF);
     SetZero(Lo(Sum) = 0);
     SetSign(Lo(Sum) AND F_SIGN <> 0);
End;

PROCEDURE dec6502;
Begin
     ADRMode[OpCode];
     Dec(CPUMem^[SavePC]);
     {PutMemory(SavePC, CPUMem^[SavePC]-1);}
     Value := CPUMem^[SavePC];
     SetZero(Value = 0);
     SetSign(Value AND F_SIGN <> 0);
End;

PROCEDURE dex6502; assembler;
{Begin
 Dec(X);
 If X <> 0 Then P := P and N_ZERO ELSE P := P OR F_ZERO;
 If X and F_SIGN <> 0 Then P := P OR F_SIGN ELSE P := P and N_SIGN;
End;}
ASM
 dec RX
 mov al, RX
 cmp al, 0
 je @neZ
  and RF, N_ZERO
  jmp @eZ
 @neZ:
  or RF, $2
 @eZ:
 and al, F_SIGN
 cmp al, 0
 je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE dey6502; assembler;
{Begin
 Dec(Y);
 If Y <> 0 Then P := P and N_ZERO ELSE P := P OR F_ZERO;
 If Y and F_SIGN <> 0 Then P := P OR F_SIGN ELSE P := P and N_SIGN;
End;}
ASM
 dec RY
 mov al, RY
 cmp al, 0
 je @neZ
  and RF, N_ZERO
  jmp @eZ
 @neZ:
  or RF, $2
 @eZ:
 and al, F_SIGN
 cmp al, 0
 je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE eor6502;
Begin
     ADRMode[OpCode];
     RA := RA XOR CPUMem^[SavePC];
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE inc6502;
Begin
     ADRMode[OpCode];
     Inc(CPUMem^[SavePC]);
     {PutMemory(SavePC, CPUMem^[SavePC]+1);}
     Value:=CPUMem^[SavePC];
     SetZero(Value = 0);
     SetSign(Value AND F_SIGN <> 0);
End;

PROCEDURE inx6502; assembler;
{Begin
 Inc(X);
 If X <> 0 Then P := P and N_ZERO ELSE P := P OR F_ZERO;
 If X and F_SIGN <> 0 Then P := P OR F_SIGN ELSE P := P and N_SIGN;
End;}
ASM
 inc RX
 mov al, RX
 cmp al, 0
 je @neZ
  and RF, N_ZERO
  jmp @eZ
 @neZ:
  or RF, $2
 @eZ:
 and al, F_SIGN
 cmp al, 0
 je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE iny6502; assembler;
{Begin
 Inc(Y);
 If Y <> 0 Then P := P and N_ZERO ELSE P := P OR F_ZERO;
 If Y and F_SIGN <> 0 Then P := P OR F_SIGN ELSE P := P and N_SIGN;
End;}
ASM
 inc RY
 mov al, RY
 cmp al, 0
 je @neZ
  and RF, N_ZERO
  jmp @eZ
 @neZ:
  or RF, $2
 @eZ:
 and al, F_SIGN
 cmp al, 0
 je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE jmp6502;
Begin
     ADRMode[OpCode];
     PC:=SavePC;
End;

PROCEDURE jsr6502;
Begin
     Inc(PC);
     PutMemory(StackOffset+RS,Hi(PC));
     Dec(RS);
     PutMemory(StackOffset+RS,BYTE(PC and $FF));
     Dec(RS);
     Dec(PC);
     ADRMode[OpCode];
     PC:=SavePC;
End;

PROCEDURE lda6502;
Begin
     ADRMode[OpCode];
     RA:= GetMem(SavePC);
     (* set the zero flag *)
     SetZero(RA = 0);
     (* set the negative flag *)
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE ldx6502;
Begin
     AdrMode[OpCode];
     RX:=CPUMem^[SavePC];
     SetZero(RX = 0);
     SetSign(RX AND F_SIGN <> 0);
End;

PROCEDURE ldy6502;
Begin
     ADRMode[OpCode];
     RY:=CPUMem^[SavePC];
     SetZero(RY = 0);
     SetSign(RY AND F_SIGN <> 0);
End;

PROCEDURE lsr6502;
Begin
     ADRMode[OpCode];
     Value:=CPUMem^[SavePC];
     (* set carry flag if shifting right, it causes a bit to be lost *)
     SetCarry(Value AND F_CARRY <> 0);
{     RF := (RF AND N_CARRY) OR (Value AND F_CARRY);}
     Value := Value shr 1;
     PutMemory(SavePC, Value);
     (* set zero flag if Value is zero *)
     SetZero(Value = 0);
     (* set negative flag to 0 *)
     SetSign(False);
End;

PROCEDURE lsra6502;
Begin
     SetCarry(RA AND F_CARRY <> 0);
{     RF := (RF AND N_CARRY) OR (RA and $1);}
     RA := RA shr 1;
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE nop6502; Assembler;
ASM End;

PROCEDURE ora6502;
Begin
     ADRMode[OpCode];
     RA := RA OR CPUMem^[SavePC];
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE pha6502;
Begin
     CPUMem^[StackOffset+RS] := RA;
     {PutMemory($100+S, A);}
     Dec(RS);
End;

PROCEDURE php6502;
Begin
     CPUMem^[StackOffset+RS] := RF;
     {PutMemory($100+S, A);}
     Dec(RS);
End;

PROCEDURE pla6502;
Begin
     Inc(RS);
     RA := CPUMem^[StackOffset+RS];
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE plp6502;
Begin
     Inc(RS);
     RF := CPUMem^[StackOffset+RS] OR F_RSRVD;
End;

PROCEDURE rol6502;
Begin
     SaveFlags := (RF AND F_CARRY);
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
     SetCarry(Value AND F_SIGN = F_SIGN);
{     RF := (RF AND N_CARRY) OR ((Value shr 7) AND F_CARRY);}
     Value := (Value shl 1) OR SaveFlags;
     PutMemory(SavePC, Value);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE rola6502;
Begin
     SaveFlags := (RF AND F_CARRY);
     SetCarry(RA AND F_SIGN = F_SIGN);
{     RF := (RF and N_CARRY) OR ((RA shr 7) AND F_CARRY);}
     RA := (RA shl 1) OR SaveFlags;
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;


(******  Is this procedure right ??? *******)

PROCEDURE ror6502;
Begin
     SaveFlags := (RF AND F_CARRY) shl 7;
     ADRMode[OpCode];
     Value := CPUMem^[SavePC];
     SetCarry(Value AND $01 = $01);
{     RF := (RF and N_CARRY) OR (Value AND F_CARRY);}
     Value := (Value shr 1) OR SaveFlags;
{     If saveflags <> 0 Then Value := Value OR F_SIGN;}
     PutMemory(SavePC, Value);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE rora6502;
Begin
     SaveFlags := (RF AND F_CARRY) shl 7;
     SetCarry(RA AND $01 = $01);
{     RF := (RF AND N_CARRY) OR (RA AND F_CARRY);}
     RA := (RA shr 1) OR SaveFlags;
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE rti6502;
Begin
     Inc(RS);
     RF := CPUMem^[StackOffset+RS] OR F_RSRVD;
     Inc(RS);
     PC := CPUMem^[StackOffset+RS];
     Inc(RS);
     PC := PC OR (CPUMem^[StackOffset+RS] shl 8);
End;

PROCEDURE rts6502;
Begin
     Inc(RS);
     PC := CPUMem^[StackOffset+RS];
     Inc(RS);
     PC := PC OR (CPUMem^[StackOffset+RS] shl 8);
     Inc(PC);
End;

PROCEDURE sbc6502;              (* ??? *)
Begin
     ADRMode[OpCode];
     Value :=  CPUMem^[SavePC] XOR $FF;
     SaveFlags := RF AND F_CARRY;

{     Sum := RA - Value - (SaveFlags XOR 1);
     SetSign(Sum AND F_SIGN = F_SIGN);
     SetZero(Sum AND F_ZERO = F_ZERO);
     SetZero(Sum < $100);
     RA := Sum AND $FF;}

     Sum := RA + Value + (SaveFlags shl 4);
     SetOverflow((Sum > $7F) OR (Sum < -$80));
     Sum := RA + Value + SaveFlags;
     SetCarry(Sum > $FF);
     RA := Sum;

     If RF AND F_DEC = F_DEC Then
     Begin
          Dec(RA,$66);
          RF := RF AND N_CARRY;
          If RA and $0F > $09 Then Inc(RA, $6);
          If RA and $F0 > $90 Then
          Begin
               Inc(RA,$60);
               RF := RF OR F_CARRY;
          End;
     End
     ELSE
       Inc(ClockTicks);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE sec6502; assembler;
ASM or RF, F_CARRY End;

PROCEDURE sed6502; assembler;
ASM or RF, F_DEC End;

PROCEDURE sei6502; assembler;
ASM or RF, F_INT End;

PROCEDURE sta6502;
Begin
 ADRMode[OpCode];
 PutMemory(SavePC, RA);
{ If RA = 2 Then WriteLn(F,'    ',Hex(SavePC),'=',CPUMem^[$200+50]);}
End;

PROCEDURE stx6502;
Begin
 ADRMode[OpCode];
 PutMemory(SavePC, RX);
End;

PROCEDURE sty6502;
Begin
 ADRMode[OpCode];
 PutMemory(SavePC, RY);
End;

PROCEDURE tax6502; assembler;
{Begin
 X := A;
 If X <> 0 Then RF := P and N_ZERO ELSE RF := P OR F_ZERO;
 If X and F_SIGN <> 0 Then RF := P OR F_SIGN ELSE RF := P and N_SIGN;
End;}
ASM
  mov al, RA
  mov RX, al
  cmp al, 0
  jnz @neZ
  or RF, F_ZERO
  jmp @eZ
 @neZ:
  and RF, N_ZERO
 @eZ:
  and al, F_SIGN
  cmp al, 0
  je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;

PROCEDURE tay6502; assembler;
{Begin
 Y := A;
 If Y <> 0 Then RF := P and N_ZERO ELSE RF := P OR F_ZERO;
 If Y and F_SIGN <> 0 Then RF := P OR F_SIGN ELSE RF := P and N_SIGN;
End;}
ASM
  mov al, RA
  mov RY, al
  cmp al, 0
  jnz @neZ
  or RF, F_ZERO
  jmp @eZ
 @neZ:
  and RF, N_ZERO
 @eZ:
  and al, F_SIGN
  cmp al, 0
  je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE tsx6502; assembler;
{Begin
 X := RS;
 If X <> 0 Then RF := P and N_ZERO ELSE RF := P OR F_ZERO;
 If X and F_SIGN <> 0 Then RF := P OR F_SIGN ELSE RF := P and N_SIGN;
End;}
ASM
  mov ax, RS
  mov RX, al
  cmp al, 0
  jnz @neZ
  or RF, F_ZERO
  jmp @eZ
 @neZ:
  and RF, N_ZERO
 @eZ:
  and al, F_SIGN
  cmp al, 0
  je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE txa6502; assembler;
{Begin
 RA := X;
 If A <> 0 Then RF := P and N_ZERO ELSE RF := P OR F_ZERO;
 If A and F_SIGN <> 0 Then RF := P OR F_SIGN ELSE RF := P and N_SIGN;
End;}
ASM
  mov al, RX
  mov RA, al
  cmp al, 0
  jnz @neZ
  or RF, F_ZERO
  jmp @eZ
 @neZ:
  and RF, N_ZERO
 @eZ:
  and al, F_SIGN
  jz @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE txs6502; assembler;
ASM
 mov al, Rx
 xor ah, ah
 mov RS, ax
End;

PROCEDURE tya6502; assembler;
{Begin
 RA := Y;
 If A <> 0 Then RF := P and N_ZERO ELSE RF := P OR F_ZERO;
 If A and F_SIGN <> 0 Then RF := P OR F_SIGN ELSE RF := P and N_SIGN;
End;}
ASM
  mov al, RY
  mov RA, al
  cmp al, 0
  je @neZ
  and RF, N_ZERO
  jmp @eZ
 @neZ:
  or RF, $2
 @eZ:
  and al, F_SIGN
  cmp al, 0
  je @ne80
  or RF, F_SIGN
  jmp @e80
 @ne80:
  and RF, N_SIGN
 @e80:
End;


PROCEDURE bra6502;
Begin
     ADRMode[OpCode];
     Inc(PC, SavePC);
     Inc(clockticks);
End;

PROCEDURE dea6502;
Begin
     Dec(RA);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE ina6502;
Begin
     Inc(RA);
     SetZero(RA = 0);
     SetSign(RA AND F_SIGN <> 0);
End;

PROCEDURE phx6502;
Begin
     {PutMemory($100+S, X);}
     CPUMem^[StackOffset+RS] := RX;
     Dec(RS);
End;

PROCEDURE plx6502;
Begin
     Inc(RS);
     RX := CPUMem^[StackOffset+RS];
     SetZero(RX = 0);
     SetSign(RX AND F_SIGN <> 0);
End;

PROCEDURE phy6502;
Begin
     {PutMemory($100+S, Y);}
     CPUMem^[StackOffset+RS] := RY;
     Dec(RS);
End;

PROCEDURE ply6502;
Begin
     Inc(RS);
     RY := CPUMem^[StackOffset+RS];
     SetZero(RY = 0);
     SetSign(RY AND F_SIGN <> 0);
End;

PROCEDURE stz6502;
Begin
     ADRMode[OpCode];
     {PutMemory(SavePC, 0);}
     CPUMem^[SavePC] := 0;
End;

PROCEDURE tsb6502;
Begin
     ADRMode[OpCode];
     CPUMem^[SavePC] := RA;
     {PutMemory(SavePC, CPUMem^[SavePC] OR A);}
     SetZero(CPUMem^[SavePC] = 0);
End;

PROCEDURE trb6502;
Begin
     ADRMode[OpCode];
     CPUMem^[SavePC] := CPUMem^[SavePC] and (RA xor $FF);
     {PutMemory(SavePC, CPUMem^[SavePC] and (A xor $FF));}
     SetZero(CPUMem^[SavePC] = 0);
End;

PROCEDURE Init6502;
Begin
 Ticks[$00]:= 7; Instruction[$00]:= brk6502;  ADRMode[$00]:= implied6502;
 Ticks[$01]:= 6; Instruction[$01]:= ora6502;  ADRMode[$01]:= indx6502;
 Ticks[$02]:= 2; Instruction[$02]:= nop6502;  ADRMode[$02]:= implied6502;
 Ticks[$03]:= 2; Instruction[$03]:= nop6502;  ADRMode[$03]:= implied6502;
 Ticks[$04]:= 3; Instruction[$04]:= tsb6502;  ADRMode[$04]:= zp6502;
 Ticks[$05]:= 3; Instruction[$05]:= ora6502;  ADRMode[$05]:= zp6502;
 Ticks[$06]:= 5; Instruction[$06]:= asl6502;  ADRMode[$06]:= zp6502;
 Ticks[$07]:= 2; Instruction[$07]:= nop6502;  ADRMode[$07]:= implied6502;
 Ticks[$08]:= 3; Instruction[$08]:= php6502;  ADRMode[$08]:= implied6502;
 Ticks[$09]:= 3; Instruction[$09]:= ora6502;  ADRMode[$09]:= immediate6502;
 Ticks[$0A]:= 2; Instruction[$0A]:= asla6502; ADRMode[$0A]:= implied6502;
 Ticks[$0B]:= 2; Instruction[$0B]:= nop6502;  ADRMode[$0B]:= implied6502;
 Ticks[$0C]:= 4; Instruction[$0C]:= tsb6502;  ADRMode[$0C]:= abs6502;
 Ticks[$0D]:= 4; Instruction[$0D]:= ora6502;  ADRMode[$0D]:= abs6502;
 Ticks[$0E]:= 6; Instruction[$0E]:= asl6502;  ADRMode[$0E]:= abs6502;
 Ticks[$0F]:= 2; Instruction[$0F]:= nop6502;  ADRMode[$0F]:= implied6502;
 Ticks[$10]:= 2; Instruction[$10]:= bpl6502;  ADRMode[$10]:= relative6502;
 Ticks[$11]:= 5; Instruction[$11]:= ora6502;  ADRMode[$11]:= indy6502;
 Ticks[$12]:= 3; Instruction[$12]:= ora6502;  ADRMode[$12]:= indzp6502;
 Ticks[$13]:= 2; Instruction[$13]:= nop6502;  ADRMode[$13]:= implied6502;
 Ticks[$14]:= 3; Instruction[$14]:= trb6502;  ADRMode[$14]:= zp6502;
 Ticks[$15]:= 4; Instruction[$15]:= ora6502;  ADRMode[$15]:= zpx6502;
 Ticks[$16]:= 6; Instruction[$16]:= asl6502;  ADRMode[$16]:= zpx6502;
 Ticks[$17]:= 2; Instruction[$17]:= nop6502;  ADRMode[$17]:= implied6502;
 Ticks[$18]:= 2; Instruction[$18]:= clc6502;  ADRMode[$18]:= implied6502;
 Ticks[$19]:= 4; Instruction[$19]:= ora6502;  ADRMode[$19]:= absy6502;
 Ticks[$1A]:= 2; Instruction[$1A]:= ina6502;  ADRMode[$1A]:= implied6502;
 Ticks[$1B]:= 2; Instruction[$1B]:= nop6502;  ADRMode[$1B]:= implied6502;
 Ticks[$1C]:= 4; Instruction[$1C]:= trb6502;  ADRMode[$1C]:= abs6502;
 Ticks[$1D]:= 4; Instruction[$1D]:= ora6502;  ADRMode[$1D]:= absx6502;
 Ticks[$1E]:= 7; Instruction[$1E]:= asl6502;  ADRMode[$1E]:= absx6502;
 Ticks[$1F]:= 2; Instruction[$1F]:= nop6502;  ADRMode[$1F]:= implied6502;
 Ticks[$20]:= 6; Instruction[$20]:= jsr6502;  ADRMode[$20]:= abs6502;
 Ticks[$21]:= 6; Instruction[$21]:= and6502;  ADRMode[$21]:= indx6502;
 Ticks[$22]:= 2; Instruction[$22]:= nop6502;  ADRMode[$22]:= implied6502;
 Ticks[$23]:= 2; Instruction[$23]:= nop6502;  ADRMode[$23]:= implied6502;
 Ticks[$24]:= 3; Instruction[$24]:= bit6502;  ADRMode[$24]:= zp6502;
 Ticks[$25]:= 3; Instruction[$25]:= and6502;  ADRMode[$25]:= zp6502;
 Ticks[$26]:= 5; Instruction[$26]:= rol6502;  ADRMode[$26]:= zp6502;
 Ticks[$27]:= 2; Instruction[$27]:= nop6502;  ADRMode[$27]:= implied6502;
 Ticks[$28]:= 4; Instruction[$28]:= plp6502;  ADRMode[$28]:= implied6502;
 Ticks[$29]:= 3; Instruction[$29]:= and6502;  ADRMode[$29]:= immediate6502;
 Ticks[$2A]:= 2; Instruction[$2A]:= rola6502; ADRMode[$2A]:= implied6502;
 Ticks[$2B]:= 2; Instruction[$2B]:= nop6502;  ADRMode[$2B]:= implied6502;
 Ticks[$2C]:= 4; Instruction[$2C]:= bit6502;  ADRMode[$2C]:= abs6502;
 Ticks[$2D]:= 4; Instruction[$2D]:= and6502;  ADRMode[$2D]:= abs6502;
 Ticks[$2E]:= 6; Instruction[$2E]:= rol6502;  ADRMode[$2E]:= abs6502;
 Ticks[$2F]:= 2; Instruction[$2F]:= nop6502;  ADRMode[$2F]:= implied6502;
 Ticks[$30]:= 2; Instruction[$30]:= bmi6502;  ADRMode[$30]:= relative6502;
 Ticks[$31]:= 5; Instruction[$31]:= and6502;  ADRMode[$31]:= indy6502;
 Ticks[$32]:= 3; Instruction[$32]:= and6502;  ADRMode[$32]:= indzp6502;
 Ticks[$33]:= 2; Instruction[$33]:= nop6502;  ADRMode[$33]:= implied6502;
 Ticks[$34]:= 4; Instruction[$34]:= bit6502;  ADRMode[$34]:= zpx6502;
 Ticks[$35]:= 4; Instruction[$35]:= and6502;  ADRMode[$35]:= zpx6502;
 Ticks[$36]:= 6; Instruction[$36]:= rol6502;  ADRMode[$36]:= zpx6502;
 Ticks[$37]:= 2; Instruction[$37]:= nop6502;  ADRMode[$37]:= implied6502;
 Ticks[$38]:= 2; Instruction[$38]:= sec6502;  ADRMode[$38]:= implied6502;
 Ticks[$39]:= 4; Instruction[$39]:= and6502;  ADRMode[$39]:= absy6502;
 Ticks[$3A]:= 2; Instruction[$3A]:= dea6502;  ADRMode[$3A]:= implied6502;
 Ticks[$3B]:= 2; Instruction[$3B]:= nop6502;  ADRMode[$3B]:= implied6502;
 Ticks[$3C]:= 4; Instruction[$3C]:= bit6502;  ADRMode[$3C]:= absx6502;
 Ticks[$3D]:= 4; Instruction[$3D]:= and6502;  ADRMode[$3D]:= absx6502;
 Ticks[$3E]:= 7; Instruction[$3E]:= rol6502;  ADRMode[$3E]:= absx6502;
 Ticks[$3F]:= 2; Instruction[$3F]:= nop6502;  ADRMode[$3F]:= implied6502;
 Ticks[$40]:= 6; Instruction[$40]:= rti6502;  ADRMode[$40]:= implied6502;
 Ticks[$41]:= 6; Instruction[$41]:= eor6502;  ADRMode[$41]:= indx6502;
 Ticks[$42]:= 2; Instruction[$42]:= nop6502;  ADRMode[$42]:= implied6502;
 Ticks[$43]:= 2; Instruction[$43]:= nop6502;  ADRMode[$43]:= implied6502;
 Ticks[$44]:= 2; Instruction[$44]:= nop6502;  ADRMode[$44]:= implied6502;
 Ticks[$45]:= 3; Instruction[$45]:= eor6502;  ADRMode[$45]:= zp6502;

 Ticks[$46]:= 5; Instruction[$46]:= lsr6502;  ADRMode[$46]:= zp6502;
 Ticks[$47]:= 2; Instruction[$47]:= nop6502;  ADRMode[$47]:= implied6502;
 Ticks[$48]:= 3; Instruction[$48]:= pha6502;  ADRMode[$48]:= implied6502;
 Ticks[$49]:= 3; Instruction[$49]:= eor6502;  ADRMode[$49]:= immediate6502;
 Ticks[$4A]:= 2; Instruction[$4A]:= lsra6502; ADRMode[$4A]:= implied6502;
 Ticks[$4B]:= 2; Instruction[$4B]:= nop6502;  ADRMode[$4B]:= implied6502;
 Ticks[$4C]:= 3; Instruction[$4C]:= jmp6502;  ADRMode[$4C]:= abs6502;
 Ticks[$4D]:= 4; Instruction[$4D]:= eor6502;  ADRMode[$4D]:= abs6502;
 Ticks[$4E]:= 6; Instruction[$4E]:= lsr6502;  ADRMode[$4E]:= abs6502;
 Ticks[$4F]:= 2; Instruction[$4F]:= nop6502;  ADRMode[$4F]:= implied6502;
 Ticks[$50]:= 2; Instruction[$50]:= bvc6502;  ADRMode[$50]:= relative6502;
 Ticks[$51]:= 5; Instruction[$51]:= eor6502;  ADRMode[$51]:= indy6502;
 Ticks[$52]:= 3; Instruction[$52]:= eor6502;  ADRMode[$52]:= indzp6502;
 Ticks[$53]:= 2; Instruction[$53]:= nop6502;  ADRMode[$53]:= implied6502;
 Ticks[$54]:= 2; Instruction[$54]:= nop6502;  ADRMode[$54]:= implied6502;
 Ticks[$55]:= 4; Instruction[$55]:= eor6502;  ADRMode[$55]:= zpx6502;
 Ticks[$56]:= 6; Instruction[$56]:= lsr6502;  ADRMode[$56]:= zpx6502;
 Ticks[$57]:= 2; Instruction[$57]:= nop6502;  ADRMode[$57]:= implied6502;
 Ticks[$58]:= 2; Instruction[$58]:= cli6502;  ADRMode[$58]:= implied6502;
 Ticks[$59]:= 4; Instruction[$59]:= eor6502;  ADRMode[$59]:= absy6502;
 Ticks[$5A]:= 3; Instruction[$5A]:= phy6502;  ADRMode[$5A]:= implied6502;
 Ticks[$5B]:= 2; Instruction[$5B]:= nop6502;  ADRMode[$5B]:= implied6502;
 Ticks[$5C]:= 2; Instruction[$5C]:= nop6502;  ADRMode[$5C]:= implied6502;
 Ticks[$5D]:= 4; Instruction[$5D]:= eor6502;  ADRMode[$5D]:= absx6502;
 Ticks[$5E]:= 7; Instruction[$5E]:= lsr6502;  ADRMode[$5E]:= absx6502;
 Ticks[$5F]:= 2; Instruction[$5F]:= nop6502;  ADRMode[$5F]:= implied6502;
 Ticks[$60]:= 6; Instruction[$60]:= rts6502;  ADRMode[$60]:= implied6502;
 Ticks[$61]:= 6; Instruction[$61]:= adc6502;  ADRMode[$61]:= indx6502;
 Ticks[$62]:= 2; Instruction[$62]:= nop6502;  ADRMode[$62]:= implied6502;
 Ticks[$63]:= 2; Instruction[$63]:= nop6502;  ADRMode[$63]:= implied6502;
 Ticks[$64]:= 3; Instruction[$64]:= stz6502;  ADRMode[$64]:= zp6502;
 Ticks[$65]:= 3; Instruction[$65]:= adc6502;  ADRMode[$65]:= zp6502;
 Ticks[$66]:= 5; Instruction[$66]:= ror6502;  ADRMode[$66]:= zp6502;
 Ticks[$67]:= 2; Instruction[$67]:= nop6502;  ADRMode[$67]:= implied6502;
 Ticks[$68]:= 4; Instruction[$68]:= pla6502;  ADRMode[$68]:= implied6502;
 Ticks[$69]:= 3; Instruction[$69]:= adc6502;  ADRMode[$69]:= immediate6502;
 Ticks[$6A]:= 2; Instruction[$6A]:= ror6502;  ADRMode[$6A]:= implied6502;
 Ticks[$6B]:= 2; Instruction[$6B]:= nop6502;  ADRMode[$6B]:= implied6502;
 Ticks[$6C]:= 5; Instruction[$6C]:= jmp6502;  ADRMode[$6C]:= indirect6502;
 Ticks[$6D]:= 4; Instruction[$6D]:= adc6502;  ADRMode[$6D]:= abs6502;
 Ticks[$6E]:= 6; Instruction[$6E]:= ror6502;  ADRMode[$6E]:= abs6502;
 Ticks[$6F]:= 2; Instruction[$6F]:= nop6502;  ADRMode[$6F]:= implied6502;
 Ticks[$70]:= 2; Instruction[$70]:= bvs6502;  ADRMode[$70]:= relative6502;
 Ticks[$71]:= 5; Instruction[$71]:= adc6502;  ADRMode[$71]:= indy6502;
 Ticks[$72]:= 3; Instruction[$72]:= adc6502;  ADRMode[$72]:= indzp6502;
 Ticks[$73]:= 2; Instruction[$73]:= nop6502;  ADRMode[$73]:= implied6502;
 Ticks[$74]:= 4; Instruction[$74]:= stz6502;  ADRMode[$74]:= zpx6502;
 Ticks[$75]:= 4; Instruction[$75]:= adc6502;  ADRMode[$75]:= zpx6502;
 Ticks[$76]:= 6; Instruction[$76]:= ror6502;  ADRMode[$76]:= zpx6502;
 Ticks[$77]:= 2; Instruction[$77]:= nop6502;  ADRMode[$77]:= implied6502;
 Ticks[$78]:= 2; Instruction[$78]:= sei6502;  ADRMode[$78]:= implied6502;
 Ticks[$79]:= 4; Instruction[$79]:= adc6502;  ADRMode[$79]:= absy6502;
 Ticks[$7A]:= 4; Instruction[$7A]:= ply6502;  ADRMode[$7A]:= implied6502;
 Ticks[$7B]:= 2; Instruction[$7B]:= nop6502;  ADRMode[$7B]:= implied6502;
 Ticks[$7C]:= 6; Instruction[$7C]:= jmp6502;  ADRMode[$7C]:= indabsx6502;
 Ticks[$7D]:= 4; Instruction[$7D]:= adc6502;  ADRMode[$7D]:= absx6502;
 Ticks[$7E]:= 7; Instruction[$7E]:= ror6502;  ADRMode[$7E]:= absx6502;
 Ticks[$7F]:= 2; Instruction[$7F]:= nop6502;  ADRMode[$7F]:= implied6502;
 Ticks[$80]:= 2; Instruction[$80]:= bra6502;  ADRMode[$80]:= relative6502;
 Ticks[$81]:= 6; Instruction[$81]:= sta6502;  ADRMode[$81]:= indx6502;
 Ticks[$82]:= 2; Instruction[$82]:= nop6502;  ADRMode[$82]:= implied6502;
 Ticks[$83]:= 2; Instruction[$83]:= nop6502;  ADRMode[$83]:= implied6502;
 Ticks[$84]:= 2; Instruction[$84]:= sty6502;  ADRMode[$84]:= zp6502;
 Ticks[$85]:= 2; Instruction[$85]:= sta6502;  ADRMode[$85]:= zp6502;
 Ticks[$86]:= 2; Instruction[$86]:= stx6502;  ADRMode[$86]:= zp6502;
 Ticks[$87]:= 2; Instruction[$87]:= nop6502;  ADRMode[$87]:= implied6502;

 Ticks[$88]:= 2; Instruction[$88]:= dey6502;  ADRMode[$88]:= implied6502;
 Ticks[$89]:= 2; Instruction[$89]:= bit6502;  ADRMode[$89]:= immediate6502;
 Ticks[$8A]:= 2; Instruction[$8A]:= txa6502;  ADRMode[$8A]:= implied6502;
 Ticks[$8B]:= 2; Instruction[$8B]:= nop6502;  ADRMode[$8B]:= implied6502;
 Ticks[$8C]:= 4; Instruction[$8C]:= sty6502;  ADRMode[$8C]:= abs6502;
 Ticks[$8D]:= 4; Instruction[$8D]:= sta6502;  ADRMode[$8D]:= abs6502;
 Ticks[$8E]:= 4; Instruction[$8E]:= stx6502;  ADRMode[$8E]:= abs6502;
 Ticks[$8F]:= 2; Instruction[$8F]:= nop6502;  ADRMode[$8F]:= implied6502;
 Ticks[$90]:= 2; Instruction[$90]:= bcc6502;  ADRMode[$90]:= relative6502;
 Ticks[$91]:= 6; Instruction[$91]:= sta6502;  ADRMode[$91]:= indy6502;
 Ticks[$92]:= 3; Instruction[$92]:= sta6502;  ADRMode[$92]:= indzp6502;
 Ticks[$93]:= 2; Instruction[$93]:= nop6502;  ADRMode[$93]:= implied6502;
 Ticks[$94]:= 4; Instruction[$94]:= sty6502;  ADRMode[$94]:= zpx6502;
 Ticks[$95]:= 4; Instruction[$95]:= sta6502;  ADRMode[$95]:= zpx6502;
 Ticks[$96]:= 4; Instruction[$96]:= stx6502;  ADRMode[$96]:= zpy6502;
 Ticks[$97]:= 2; Instruction[$97]:= nop6502;  ADRMode[$97]:= implied6502;
 Ticks[$98]:= 2; Instruction[$98]:= tya6502;  ADRMode[$98]:= implied6502;
 Ticks[$99]:= 5; Instruction[$99]:= sta6502;  ADRMode[$99]:= absy6502;
 Ticks[$9A]:= 2; Instruction[$9A]:= txs6502;  ADRMode[$9A]:= implied6502;
 Ticks[$9B]:= 2; Instruction[$9B]:= nop6502;  ADRMode[$9B]:= implied6502;
 Ticks[$9C]:= 4; Instruction[$9C]:= stz6502;  ADRMode[$9C]:= abs6502;
 Ticks[$9D]:= 5; Instruction[$9D]:= sta6502;  ADRMode[$9D]:= absx6502;
 Ticks[$9E]:= 5; Instruction[$9E]:= stz6502;  ADRMode[$9E]:= absx6502;
 Ticks[$9F]:= 2; Instruction[$9F]:= nop6502;  ADRMode[$9F]:= implied6502;
 Ticks[$A0]:= 3; Instruction[$A0]:= ldy6502;  ADRMode[$A0]:= immediate6502;
 Ticks[$A1]:= 6; Instruction[$A1]:= lda6502;  ADRMode[$A1]:= indx6502;
 Ticks[$A2]:= 3; Instruction[$A2]:= ldx6502;  ADRMode[$A2]:= immediate6502;
 Ticks[$A3]:= 2; Instruction[$A3]:= nop6502;  ADRMode[$A3]:= implied6502;
 Ticks[$A4]:= 3; Instruction[$A4]:= ldy6502;  ADRMode[$A4]:= zp6502;
 Ticks[$A5]:= 3; Instruction[$A5]:= lda6502;  ADRMode[$A5]:= zp6502;
 Ticks[$A6]:= 3; Instruction[$A6]:= ldx6502;  ADRMode[$A6]:= zp6502;
 Ticks[$A7]:= 2; Instruction[$A7]:= nop6502;  ADRMode[$A7]:= implied6502;
 Ticks[$A8]:= 2; Instruction[$A8]:= tay6502;  ADRMode[$A8]:= implied6502;
 Ticks[$A9]:= 3; Instruction[$A9]:= lda6502;  ADRMode[$A9]:= immediate6502;
 Ticks[$AA]:= 2; Instruction[$AA]:= tax6502;  ADRMode[$AA]:= implied6502;
 Ticks[$AB]:= 2; Instruction[$AB]:= nop6502;  ADRMode[$AB]:= implied6502;
 Ticks[$AC]:= 4; Instruction[$AC]:= ldy6502;  ADRMode[$AC]:= abs6502;
 Ticks[$AD]:= 4; Instruction[$AD]:= lda6502;  ADRMode[$AD]:= abs6502;
 Ticks[$AE]:= 4; Instruction[$AE]:= ldx6502;  ADRMode[$AE]:= abs6502;
 Ticks[$AF]:= 2; Instruction[$AF]:= nop6502;  ADRMode[$AF]:= implied6502;
 Ticks[$B0]:= 2; Instruction[$B0]:= bcs6502;  ADRMode[$B0]:= relative6502;
 Ticks[$B1]:= 5; Instruction[$B1]:= lda6502;  ADRMode[$B1]:= indy6502;
 Ticks[$B2]:= 3; Instruction[$B2]:= lda6502;  ADRMode[$B2]:= indzp6502;
 Ticks[$B3]:= 2; Instruction[$B3]:= nop6502;  ADRMode[$B3]:= implied6502;
 Ticks[$B4]:= 4; Instruction[$B4]:= ldy6502;  ADRMode[$B4]:= zpx6502;
 Ticks[$B5]:= 4; Instruction[$B5]:= lda6502;  ADRMode[$B5]:= zpx6502;
 Ticks[$B6]:= 4; Instruction[$B6]:= ldx6502;  ADRMode[$B6]:= zpy6502;
 Ticks[$B7]:= 2; Instruction[$B7]:= nop6502;  ADRMode[$B7]:= implied6502;
 Ticks[$B8]:= 2; Instruction[$B8]:= clv6502;  ADRMode[$B8]:= implied6502;
 Ticks[$B9]:= 4; Instruction[$B9]:= lda6502;  ADRMode[$B9]:= absy6502;
 Ticks[$BA]:= 2; Instruction[$BA]:= tsx6502;  ADRMode[$BA]:= implied6502;
 Ticks[$BB]:= 2; Instruction[$BB]:= nop6502;  ADRMode[$BB]:= implied6502;
 Ticks[$BC]:= 4; Instruction[$BC]:= ldy6502;  ADRMode[$BC]:= absx6502;
 Ticks[$BD]:= 4; Instruction[$BD]:= lda6502;  ADRMode[$BD]:= absx6502;
 Ticks[$BE]:= 4; Instruction[$BE]:= ldx6502;  ADRMode[$BE]:= absy6502;
 Ticks[$BF]:= 2; Instruction[$BF]:= nop6502;  ADRMode[$BF]:= implied6502;
 Ticks[$C0]:= 3; Instruction[$C0]:= cpy6502;  ADRMode[$C0]:= immediate6502;
 Ticks[$C1]:= 6; Instruction[$C1]:= cmp6502;  ADRMode[$C1]:= indx6502;
 Ticks[$C2]:= 2; Instruction[$C2]:= nop6502;  ADRMode[$C2]:= implied6502;
 Ticks[$C3]:= 2; Instruction[$C3]:= nop6502;  ADRMode[$C3]:= implied6502;
 Ticks[$C4]:= 3; Instruction[$C4]:= cpy6502;  ADRMode[$C4]:= zp6502;
 Ticks[$C5]:= 3; Instruction[$C5]:= cmp6502;  ADRMode[$C5]:= zp6502;
 Ticks[$C6]:= 5; Instruction[$C6]:= dec6502;  ADRMode[$C6]:= zp6502;
 Ticks[$C7]:= 2; Instruction[$C7]:= nop6502;  ADRMode[$C7]:= implied6502;
 Ticks[$C8]:= 2; Instruction[$C8]:= iny6502;  ADRMode[$C8]:= implied6502;
 Ticks[$C9]:= 3; Instruction[$C9]:= cmp6502;  ADRMode[$C9]:= immediate6502;

 Ticks[$CA]:= 2; Instruction[$CA]:= dex6502;  ADRMode[$CA]:= implied6502;
 Ticks[$CB]:= 2; Instruction[$CB]:= nop6502;  ADRMode[$CB]:= implied6502;
 Ticks[$CC]:= 4; Instruction[$CC]:= cpy6502;  ADRMode[$CC]:= abs6502;
 Ticks[$CD]:= 4; Instruction[$CD]:= cmp6502;  ADRMode[$CD]:= abs6502;
 Ticks[$CE]:= 6; Instruction[$CE]:= dec6502;  ADRMode[$CE]:= abs6502;
 Ticks[$CF]:= 2; Instruction[$CF]:= nop6502;  ADRMode[$CF]:= implied6502;
 Ticks[$D0]:= 2; Instruction[$D0]:= bne6502;  ADRMode[$D0]:= relative6502;
 Ticks[$D1]:= 5; Instruction[$D1]:= cmp6502;  ADRMode[$D1]:= indy6502;
 Ticks[$D2]:= 3; Instruction[$D2]:= cmp6502;  ADRMode[$D2]:= indzp6502;
 Ticks[$D3]:= 2; Instruction[$D3]:= nop6502;  ADRMode[$D3]:= implied6502;
 Ticks[$D4]:= 2; Instruction[$D4]:= nop6502;  ADRMode[$D4]:= implied6502;
 Ticks[$D5]:= 4; Instruction[$D5]:= cmp6502;  ADRMode[$D5]:= zpx6502;
 Ticks[$D6]:= 6; Instruction[$D6]:= dec6502;  ADRMode[$D6]:= zpx6502;
 Ticks[$D7]:= 2; Instruction[$D7]:= nop6502;  ADRMode[$D7]:= implied6502;
 Ticks[$D8]:= 2; Instruction[$D8]:= cld6502;  ADRMode[$D8]:= implied6502;
 Ticks[$D9]:= 4; Instruction[$D9]:= cmp6502;  ADRMode[$D9]:= absy6502;
 Ticks[$DA]:= 3; Instruction[$DA]:= phx6502;  ADRMode[$DA]:= implied6502;
 Ticks[$DB]:= 2; Instruction[$DB]:= nop6502;  ADRMode[$DB]:= implied6502;
 Ticks[$DC]:= 2; Instruction[$DC]:= nop6502;  ADRMode[$DC]:= implied6502;
 Ticks[$DD]:= 4; Instruction[$DD]:= cmp6502;  ADRMode[$DD]:= absx6502;
 Ticks[$DE]:= 7; Instruction[$DE]:= dec6502;  ADRMode[$DE]:= absx6502;
 Ticks[$DF]:= 2; Instruction[$DF]:= nop6502;  ADRMode[$DF]:= implied6502;
 Ticks[$E0]:= 3; Instruction[$E0]:= cpx6502;  ADRMode[$E0]:= immediate6502;
 Ticks[$E1]:= 6; Instruction[$E1]:= sbc6502;  ADRMode[$E1]:= indx6502;
 Ticks[$E2]:= 2; Instruction[$E2]:= nop6502;  ADRMode[$E2]:= implied6502;
 Ticks[$E3]:= 2; Instruction[$E3]:= nop6502;  ADRMode[$E3]:= implied6502;
 Ticks[$E4]:= 3; Instruction[$E4]:= cpx6502;  ADRMode[$E4]:= zp6502;
 Ticks[$E5]:= 3; Instruction[$E5]:= sbc6502;  ADRMode[$E5]:= zp6502;
 Ticks[$E6]:= 5; Instruction[$E6]:= inc6502;  ADRMode[$E6]:= zp6502;
 Ticks[$E7]:= 2; Instruction[$E7]:= nop6502;  ADRMode[$E7]:= implied6502;
 Ticks[$E8]:= 2; Instruction[$E8]:= inx6502;  ADRMode[$E8]:= implied6502;
 Ticks[$E9]:= 3; Instruction[$E9]:= sbc6502;  ADRMode[$E9]:= immediate6502;
 Ticks[$EA]:= 2; Instruction[$EA]:= nop6502;  ADRMode[$EA]:= implied6502;
 Ticks[$EB]:= 2; Instruction[$EB]:= nop6502;  ADRMode[$EB]:= implied6502;
 Ticks[$EC]:= 4; Instruction[$EC]:= cpx6502;  ADRMode[$EC]:= abs6502;
 Ticks[$ED]:= 4; Instruction[$ED]:= sbc6502;  ADRMode[$ED]:= abs6502;
 Ticks[$EE]:= 6; Instruction[$EE]:= inc6502;  ADRMode[$EE]:= abs6502;
 Ticks[$EF]:= 2; Instruction[$EF]:= nop6502;  ADRMode[$EF]:= implied6502;
 Ticks[$F0]:= 2; Instruction[$F0]:= beq6502;  ADRMode[$F0]:= relative6502;
 Ticks[$F1]:= 5; Instruction[$F1]:= sbc6502;  ADRMode[$F1]:= indy6502;
 Ticks[$F2]:= 3; Instruction[$F2]:= sbc6502;  ADRMode[$F2]:= indzp6502;
 Ticks[$F3]:= 2; Instruction[$F3]:= nop6502;  ADRMode[$F3]:= implied6502;
 Ticks[$F4]:= 2; Instruction[$F4]:= nop6502;  ADRMode[$F4]:= implied6502;
 Ticks[$F5]:= 4; Instruction[$F5]:= sbc6502;  ADRMode[$F5]:= zpx6502;
 Ticks[$F6]:= 6; Instruction[$F6]:= inc6502;  ADRMode[$F6]:= zpx6502;
 Ticks[$F7]:= 2; Instruction[$F7]:= nop6502;  ADRMode[$F7]:= implied6502;
 Ticks[$F8]:= 2; Instruction[$F8]:= sed6502;  ADRMode[$F8]:= implied6502;
 Ticks[$F9]:= 4; Instruction[$F9]:= sbc6502;  ADRMode[$F9]:= absy6502;
 Ticks[$FA]:= 4; Instruction[$FA]:= plx6502;  ADRMode[$FA]:= implied6502;
 Ticks[$FB]:= 2; Instruction[$FB]:= nop6502;  ADRMode[$FB]:= implied6502;
 Ticks[$FC]:= 2; Instruction[$FC]:= nop6502;  ADRMode[$FC]:= implied6502;
 Ticks[$FD]:= 4; Instruction[$FD]:= sbc6502;  ADRMode[$FD]:= absx6502;
 Ticks[$FE]:= 7; Instruction[$FE]:= inc6502;  ADRMode[$FE]:= absx6502;
 Ticks[$FF]:= 2; Instruction[$FF]:= nop6502;  ADRMode[$FF]:= implied6502;
End;

{/\/\/\/\Reset CPU/\/\/\/\}
PROCEDURE Reset6502;
Begin
 RA:=0;RX:=0;RY:=0;RF:=0;                             { Clear All Registers }
 RF := RF OR F_RSRVD;                                 { Set RF := F_RSRVD   }
 RS := $FF;                                           { Set RS := $FF (255) }
 Move(CPUMem^[$FFFC],PC,2);
 NewROM := True; JoyCounter := 0;
End;

{/\/\/\/\Non-maskable Interrupt/\/\/\/\}
PROCEDURE nmi6502;
Begin
 PutMemory(StackOffset+RS, BYTE(PC shr 8));
 Dec(RS);
 PutMemory(StackOffset+RS, BYTE(PC and $FF));
 Dec(RS);
 PutMemory(StackOffset+RS, RF);
 Dec(RS);
 RF := RF OR F_INT;
 Move(CPUMem^[$FFFA],PC,2);
 {PC := PC OR (CPUMem^[$FFFB] shl 8);}
End;

{/\/\/\/\maskable Interrupt/\/\/\/\}
PROCEDURE irq6502;
Begin
 PutMemory(StackOffset+RS, BYTE(PC shr 8));
 Dec(RS);
 PutMemory(StackOffset+RS, BYTE(PC and $FF));
 Dec(RS);
 PutMemory(StackOffset+RS, RF);
 Dec(RS);
 RF := RF OR F_INT;
 PC := CPUMem^[$FFFE] + (CPUMem^[$FFFF] shl 8);
End;

PROCEDURE PPUCheck;
VAR
 byt : byte;
 wrd : word;
Begin
{PPUCNT0}
     Byt := CPUMem^[$2000];
     Exec_NMI_VBlank       := Boolean(Byt AND $80);           { False/True  }
     Exec_NMI_Sprite_Hit   := Boolean(Byt AND $40);           { False/True  }
     Sprite_Size           := (Byt AND $20) Shr 5;            { $0000/$0001 }
     Scr_Pat_Tab_Adr       := (Byt AND $10) Shl 8;            { $0000/$1000 }
     Spr_Pat_Tab_Adr       := (Byt AND $08) Shl 9;            { $0000/$1000 }
{     PPU_Adr_RW_inc        := (Byt AND $04) Shl 3;}          { $0001/$0020 }
     If (Byt AND 4) = 0 Then PPU_Adr_RW_inc := 1 ELSE PPU_Adr_RW_Inc := 32;
     Name_Table_Select     := ((Byt AND $01) Shl 10) +        { $0000/$0400 }
                              ((Byt AND $02) Shl 10) +        { $0000/$0800 }
                              $2000;              { $2000/$2400/$2800/$2C00 }
{PPUCNT1}
 Byt := CPUMem^[$2001];
 BGcolor := ((Byt AND $20) SHR 5) +                     { (Byt AND  32) = 1 }
            ((Byt AND $40) SHR 5) +                     { (Byt AND  64) = 2 }
            ((Byt AND $80) SHR 5);                      { (Byt AND 128) = 4 }
 Spr_Disp                  := Boolean(Byt AND $10);           { False/True  }
 Scr_Disp                  := Boolean(Byt AND $08);           { False/True  }
 Spr_Clip                  := Boolean(Byt AND $04);           { False/True  }
 Img_Clip                  := Boolean(Byt AND $02);           { False/True  }
 Clr_Disp                  := Boolean(Byt AND $01);           { False/True  }
End;

PROCEDURE DumpVRAM;
VAR
 i : word;
 c : byte;
Begin
 for i := $2000 to 16384 do Begin
  c := PPUMem[i];
  ASM
   mov ax, $A000
   mov es, ax
   mov di, i
   mov al, c
   mov es:[di],al
  End;
 End;
End;

PROCEDURE DumpSprRam;
VAR
 i : word;
 c : byte;
Begin
 for i := 0 to $100 do Begin
  c := SprRAM[i];
  ASM
   mov ax, $A000
   mov es, ax
   mov di, i
   mov al, c
   mov es:[di],al
  End;
 End;
End;

PROCEDURE DrawTable0;
VAR
 X, Y, Count,
 X2, Y2         : Shortint;
 TScroll,
 LScroll        : Byte;
 Byte1, Byte2,
 color          : Byte;
 Icon           : Byte;
 NameTadr       : word;
 ScreenAdr      : word;
 AttAdr         : word;

 Z : Byte;

Begin
      TScroll := (Scroll AND $FF) shr $03;      { Take only High 8 bits  }
      LScroll := Scroll AND $07;
      NameTadr := Name_Table_Select;  { 20xx/28xx }
      AttAdr   := Name_Table_Select + $3C0;
      If Scroll >= 240 Then
      Begin
           TScroll := 0;
           LScroll := 0;
      End;
{
For X := 0 to 2 Do
Begin
For Z := 0 to 33 Do Mem[$A000:X*34+Z       ] := 120;
For Z := 0 to 33 Do Mem[$A000:X*34+Z+33*256] := 120;
For Z := 0 to 33 Do Mem[$A000:X*34+   Z*256] := 120;
For Z := 0 to 33 Do Mem[$A000:X*34+33+Z*256] := 120;
End;
}
      Y := TScroll;
      Repeat
            For X := 0 to 31 Do
            Begin
{
Icon := PPUMem[Name_Table_Select + (Y shl 5) + X];
Mem[$A000:35+X+(Y+1)*256] := Icon;
Icon := PPUMem[Name_Table_Select XOR $800 + (Y shl 5) + X];
Mem[$A000:69+X+(Y+1)*256] := Icon;
}
                 Icon := PPUMem[NameTAdr + (Y shl 5) + X];
                 If NOT(Img_Clip) AND (X = 0) Then Continue;
{
If Y < TScroll Then
   Mem[$A000:1+X+(TScroll+32-(Y+TScroll))*256] := Icon
ELSE If Y >= TScroll Then
   Mem[$A000:1+X+(Y-TScroll+1)*256] := Icon;
{                 Icon := PPUMem[AttAdr + (X shr 2) + (Y shr 2) shl 3];}
                 ScreenAdr := (Icon shl 4) + Scr_Pat_Tab_Adr - 1;
                 Y2 := LScroll;
                 Repeat
                       Color := PPUMem[AttAdr + (X shr 2) + (Y shr 2) shl 3];
                       Byte1 := PPUMem[ScreenAdr + Y2];
                       Byte2 := PPUMem[ScreenAdr + Y2 + 8];
                       For X2 := 0 to 7 Do
                       Begin
                            Color := Color AND $0C;
                            If Byte1 and (1 shl (7-X2)) <> 0 Then
                               Color := Color OR 1;
                            If Byte2 and (1 shl (7-X2)) <> 0 Then
                               Color := Color OR 2;

                            ASM
                               mov es, Page1              { ES = Page1 }
                               mov al, Y
                               sub al, TScroll
                               shl al, 3             { AL = Tiley3 * 8 }
                               and ah, 00001111b    { Max 240, w/ wrap }
                               add al, Y2       { AL = Tiley3 * 8 + Ty }
                               sub al, LScroll
                               mov cl, X                 { CL = Tilex3 }
                               shl cl, 3           { CL = (Tilex3) * 8 }
                               add cl, X2       { CL = (Tilex3)*8 + Tx }
                               shl ax, 8        { AH = Tiley3 * 8 + Ty }
                               mov di, ax       { DI = Tiley3 * 8 + Ty }
                               add di, cx
                               mov al, color
                               mov es:[di], al
                              End;
                       End;
                       Inc(Y2);
                       If Y2 = $08 Then
                       Begin
                            Y2 := 0;
                       End;
                 Until Y2 = LScroll;
            End;
            Inc(Y);
            Y := Y AND $1F;
            If Y = $00 Then
            Begin
                 NameTadr := NameTadr XOR $800;
{                 Name_Table_Select XOR $800;  { 20xx/28xx }
                 AttAdr   := NameTadr + $3C0;             { 23C0/2BC0 }
            End;
      Until Y = TScroll;
{For Z := 0 to 239 Do
Mem[$A000:Z*256] := Z DIV 20 * 5;}
End;

PROCEDURE DrawTable10;
VAR
 tilex, tiley, tilet,
 tilex2, tiley2,
 tilex3, tiley3,
 tB1, tB2, tB3, tB4,
 Tx, Ty, Tx2,
 pByte1, pByte2,
 pByte3, pByte4,
 color, ucolor : byte;
 pB1, pB2, pB3, pB4  : boolean;
 NameTadr : word;
 ScreenAdr : word;
 AttAdr : word;
{H Scrolling vars}
 Sc : byte;
 Sct : byte;
 Vty,Vtx,Vt2 : shortint;
 StartA, StartA2 : byte;

Begin
 If VertMirror Then
 Begin
      Sc       := Scroll shr 8;       { Take only Low 8 bits }
      Sct      := Sc     shr 3;
      Sc       := Sc     mod 8;
      StartA   := Sct    shr 2;
      StartA2  := Sct    mod 4;
      NameTadr := Name_Table_Select;
      AttAdr   := Name_Table_Select + $3C0;

      For Vty := 0 to 31 do { 0-31?? }
      Begin
           NameTadr := Name_Table_Select;
           Vt2 := 0;
           For Vtx := Sct to 31 do
           Begin
                VTable[Vt2,Vty] := PPUMem[NameTadr+ Vty shl 5 + Vtx];
                Inc(Vt2);
           End;
           If Name_Table_Select = $2000 Then
              NameTadr:= $2400
           ELSE NameTadr:= $2000;
           for Vtx := 0 to Sct do
           Begin
                VTable[Vt2,Vty] := PPUMem[NameTadr+ Vty shl 5 + Vtx];
                Inc(Vt2);
           End;
      End;
      Inc(AttAdr, StartA);
 End
 ELSE
 Begin
      Sc       := Scroll AND $FF;     { Take only High 8 bits  }
      If Scroll >= 240 Then Sc := 0;
      Sct      := Sc     shr 3;                 { Number of Tiles (Sc/8) }
      Sc       := Sc     mod 8;                 { Number of Pixels/Tile  }
      StartA   := (Sct   AND $1C) shl 1;        { Number of Tiles/4 ??   }
      StartA2  := (Sct   AND $03);              { Number of Pixels/Tile  }
      NameTadr := Name_Table_Select AND $2BFF;  { 20xx/28xx }
      AttAdr   := Name_Table_Select + $3C0;

      For Vtx := 0 to 31 do
      Begin
           Vt2 := 0;
           For Vty := Sct to 30 do
           Begin
                VTable[Vtx,Vt2] := PPUMem[Name_Table_Select+ Vty shl 5 + Vtx];
                Inc(Vt2);
           End;
           If Name_Table_Select = $2000 Then NameTadr:= $2800
              ELSE NameTadr:= $2000;
           for Vty := 1 to Sct do
           Begin
                VTable[Vtx,Vt2] := PPUMem[NameTadr+ (Vty-1) shl 5 + Vtx];
                Inc(Vt2);
           End;
      End;

      Inc(AttAdr, StartA); {???}
      {$IFDEF DEBUG}
      WriteLn(T,'ATTRADDR: ',Hex(Name_Table_Select + $3C0));
      WriteLn(T,'STARTA  : ',Hex(StartA));
      WriteLn(T,'STARTA2 : ',Hex(StartA2));
      WriteLn(T,'ATTRSTRT: ',Hex(AttAdr));
      {$ENDIF}
 End;

 for tiley := 0 to 7 do                                       { Each Tile Y }
  for tilex := 0 to 7 do                                      { Each Tile X }
  Begin
       pByte1 := PPUMem[AttAdr];        { Get Attribute for TileX, TileY ?}
       Inc(AttAdr);
       If VertMirror Then
       Begin
            If AttAdr >= $2400 Then
               Attadr := $27C0  { $27C0 }
       End
       ELSE
       Begin
            If (AttAdr >= $2400) and (AttAdr < $2800) Then
               Attadr := $2BC0
            ELSE
            If (AttAdr >= $2C00) and (AttAdr < $3000) Then
               Attadr := $23C0;
       End;
       Tx2 := 0;
       for tiley2 := (tiley shl 2) to (tiley shl 2) + 3 do    { TileY What? }
       Begin
            for tilex2 := (tilex shl 2) to (tilex shl 2) + 3 do    { TileX? }
            Begin
                 ucolor := 0;
                 If (pByte1 AND (1 shl (Tx2  ))) <> 0 Then UColor := UColor OR 4;
                 If (pByte1 AND (1 shl (Tx2+1))) <> 0 Then UColor := UColor OR 8;
                 Inc(Tx2,2);
                 for tiley3 := tiley2 to tiley2+1 do
                  for tilex3 := tilex2 to tilex2+1 do
                  Begin
                       tilet := VTable[tilex3, tiley3];
                       ScreenAdr := (tilet shl 4) + Scr_Pat_Tab_Adr - 1;
                       for Ty := 0 to 7 do                    { Each Icon Y }
                       Begin
                            pByte3 := PPUMem[ScreenAdr];
                            pByte4 := PPUMem[ScreenAdr+8];
                            Inc(ScreenAdr);
                            for Tx := 0 to 7 do               { Each Icon X }
                            Begin
                                 color := ucolor;
                                 If pByte3 and (1 shl (7-Tx)) <> 0 Then Color := Color OR 1;
                                 If pByte4 and (1 shl (7-Tx)) <> 0 Then Color := Color OR 2;
                                 ASM
                                    mov es, Page1              { ES = Page1 }
                                    mov al, tiley3            { AL = Tiley3 }
                                    shl al, 3             { AL = Tiley3 * 8 }
                                    add al, Ty       { AL = Tiley3 * 8 + Ty }
                                    mov cl, tilex3            { CL = Tilex3 }
                                    shl cl, 3           { CL = (Tilex3) * 8 }
                                    add cl, Tx       { CL = (Tilex3)*8 + Tx }
                                    cmp VertMirror, 0
                                    jnz @HorizMirror
                                    sub al, Sc
                                    jmp @Continue
                                   @HorizMirror:
                                    sub cl, Sc
                                   @Continue:
                                    shl ax, 8        { AH = Tiley3 * 8 + Ty }
                                    mov di, ax       { DI = Tiley3 * 8 + Ty }
                                    add di, cx
                                    mov al, color
                                    mov es:[di], al
                                 End;
                            End;
                       End;
                  End;
                 Inc(tilex2);
            End;
            Inc(tiley2);
       End;
  End;
End;

(*
PROCEDURE DrawTable0;
VAR
 tilex, tiley, tilet,
 tilex2, tiley2,
 tilex3, tiley3,
 tB1, tB2, tB3, tB4,
 Tx, Ty, Tx2,
 pByte1, pByte2,
 pByte3, pByte4,
 color, ucolor : byte;
 pB1, pB2, pB3, pB4  : boolean;
 NameTadr : word;
 ScreenAdr : word;
 AttAdr : word;
{H Scrolling vars}
 Sc : byte;
 Sct : byte;
 Vty,Vtx,Vtx2 : byte;
 StartA, StartA2 : byte;

Begin
{If Scr_Disp Then Begin}
 Sc := Scroll shr 8;
 Sct := Sc shr 4;
 Sc := Sc mod 8;
 StartA := Sct shr 2;
 StartA2 := Sct mod 4;
 NameTadr := Name_Table_Select-4;
 AttAdr := Name_Table_Select + $3C0;
 for Vty := 0 to 32 do Begin
  NameTadr := Name_Table_Select-4;
  Vtx2 := 0;
  for Vtx := Sct to 35 do Begin
   VTable[Vtx2,Vty] := PPUMem[Vty shl 5 + Vtx + NameTadr];
   Inc(Vtx2);
  End;
  If Name_Table_Select = $2000 Then NameTadr:= $2400 ELSE NameTadr:= $2000;
  for Vtx := 0 to Sct do Begin
   VTable[Vtx2,Vty] := PPUMem[Vty shl 5 + Vtx + NameTadr];
   Inc(Vtx2);
  End;
 End;
 Inc(AttAdr, StartA);
 NameTadr := Name_Table_Select-4;
 for tiley := 0 to 6 do Begin
  for tilex := 1 to 8 do Begin
   pByte1 := PPUMem[AttAdr];
   Inc(AttAdr);
   If AttAdr >= $2400 Then Attadr := $27C0;
   Tx2 := 0;
   for tiley2 := (tiley shl 2) to (tiley shl 2) + 3 do Begin
    for tilex2 := (tilex shl 2) to (tilex shl 2) + 3 do Begin
     ucolor := 0;
     If pByte1 and (1 shl Tx2) <> 0 Then Inc(ucolor, 4);
     If pByte1 and (1 shl (Tx2+1)) <> 0 Then Inc(ucolor, 8);
     Inc(Tx2,2);
     for tiley3 := tiley2 to tiley2+1 do Begin
      for tilex3 := tilex2 to tilex2+1 do Begin
       tilet := VTable[tilex3, tiley3];
       ScreenAdr := (tilet shl 4) + Scr_Pat_Tab_Adr - 1;
       for Ty := 0 to 7 do Begin
        pByte3 := PPUMem[ScreenAdr];
        pByte4 := PPUMem[ScreenAdr+8];
        Inc(ScreenAdr);
        for Tx := 0 to 7 do Begin
         color := ucolor;
         If pByte3 and (1 shl (7-Tx)) <> 0 Then Inc(color, 1);
         If pByte4 and (1 shl (7-Tx)) <> 0 Then Inc(color, 2);
         ASM
          mov es, Page1
          mov al, tiley3
          shl al, 3
          add al, Ty
          shl ax, 8
          mov di, ax
          mov cl, tilex3
          sub cl, 4
          shl cl, 3
          add cl, Tx
          sub cl, Sc
          add di, cx
          mov al, color
          mov es:[di], al
         End;
        End;
       End;
      End;
     End;
     Inc(tilex2);
    End;
    Inc(tiley2);
   End;
  End;
 End;
{End;}
End;
*)

PROCEDURE DrawSprites0;
VAR
 Sprite : byte;
 SpriteAdr : byte;
 Vflip,Hflip : boolean;
 ucolor, color : byte;
 ScreenAdr : word;
 pByte3, pByte4 : byte;
 Tx, Ty : byte;
 Ty1,Ty2,
 Tx1,Tx2,
 Txx,Tyy,
 i : shortint;
 Tyi,Txi : shortint;
 Sx,Sy,Si,Sb : byte;
Begin
  If Spr_Disp Then
  Begin
     for Sprite := 0 to 63 do           { Total Max # of sprites on screen }
     Begin
          SpriteAdr := Sprite shl 2;    { SpriteAddr = Sprite * 4          }
          ucolor := 0;                  { Clear UColor                     }
          Sy := SprRAM[SpriteAdr];      {    }
          Si := SprRAM[SpriteAdr+1];    { Sprite Pattern Number            }
          Sb := SprRAM[SpriteAdr+2];    { Sprite Data Byte                 }
          Sx := SprRAM[SpriteAdr+3];    {    }
          If Sb AND 128 <> 0 Then
          Begin
               Vflip := True;
               Ty1 := 8;
               Ty2 := 0;
               Tyi := -1;
          end
          ELSE
          Begin
               Vflip := False;
               Ty1 := 0;
               Ty2 := 8;
               Tyi := 1;
          End;
          If Sb and 64 <> 0 Then
          Begin
               Hflip := True;
               Tx1 := 9;
               Tx2 := 0;
               Txi := -1;
          end
          ELSE
          Begin
               Hflip := False;
               Tx1 := 0;
               Tx2 := 8;
               Txi := 1;
          End;
          ucolor := 16 + (Sb AND 3) shl 2;

          If Sy < 240 Then
             If (Sx <> 0) OR (Sy <> 0) Then
                If (Sx > 8) OR (Spr_Clip) Then
                   for i := 0 to Sprite_Size do
                   Begin
                        If i <> 0 Then                  {??????}
                           ASM ror Si, 1 End;
                        ScreenAdr := (Si shl 4) + (Spr_Pat_Tab_Adr)-1;
                        Ty := Ty1;
                        Tyy := i shl 3;                 {??????}
                        repeat
                              Inc(Ty, Tyi);
                              pByte3 := PPUMem[ScreenAdr];
                              pByte4 := PPUMem[ScreenAdr+8];
                              Inc(ScreenAdr);
                              Tx := Tx1;
                              Txx := 0;
                              repeat
                                    Inc(Tx,Txi);
                                    Inc(Txx);
                                    color := ucolor;
                                    If pByte3 AND (1 shl (8-Tx)) <> 0 Then
                                       Inc(color, 1);
                                    If pByte4 AND (1 shl (8-Tx)) <> 0 Then
                                       Inc(color, 2);
                                    ASM
                                       mov al, color
                                       cmp al, ucolor
                                       je @skipP
                                       mov es, Page1
                                       mov al, Sy
                                       add al, Ty
                                       add al, Tyy
                                       shl ax, 8
                                       mov al, Sx
                                       add al, Txx
                                       mov di, ax
                                       mov al, color
                                       mov es:[di], al
                                      @skipP:
                                    End;
                              until Tx = Tx2;
                        until Ty = Ty2;
                   End;
     End;
  End;
End;


PROCEDURE DrawTable1;
VAR
 tilex, tiley, tilet,
 tilex2, tiley2,
 tilex3, tiley3,
 tB1, tB2, tB3, tB4,
 Tx, Ty, Tx2,
 pByte1, pByte2,
 pByte3, pByte4,
 color, ucolor : byte;
 pB1, pB2, pB3, pB4  : boolean;
 NameTadr : word;
 ScreenAdr : word;
 AttAdr : word;
{H Scrolling vars}
 Sc : byte;
 Sct : byte;
 Vty,Vtx,Vtx2 : byte;
 StartA, StartA2 : byte;

Begin
{If Not(Scr_Disp) Then}
 If VertMirror Then    { Horizontal Scrolling }
 Begin
      Sc := Scroll shr 8;
      Sct := Sc shr 4;
      Sc := Sc mod 8;
      StartA := Sct shr 2;
      StartA2 := Sct mod 4;
      NameTadr := Name_Table_Select-4;
      AttAdr := Name_Table_Select + $3C0;
      for Vty := 0 to 31 do
      Begin
           NameTadr := Name_Table_Select-4;
           Vtx2 := 0;
           for Vtx := Sct to 31 do
           Begin
                VTable[Vtx2,Vty] := PPUMem[Vty shl 5 + Vtx + NameTadr];
                Inc(Vtx2);
           End;
           If Name_Table_Select = $2000 Then
              NameTadr:= $2400
           ELSE NameTadr:= $2000;
           for Vtx := 0 to Sct do
           Begin
                VTable[Vtx2,Vty] := PPUMem[Vty shl 5 + Vtx + NameTadr];
                Inc(Vtx2);
           End;
      End;
 End
 ELSE                   { Vertical Scrolling }
 Begin
      Sc := Scroll AND 255;
      Sct := Sc shr 4;
      Sc := Sc mod 8;
      StartA := Sct shr 2;
      StartA2 := Sct mod 4;
      NameTadr := Name_Table_Select;
      AttAdr := Name_Table_Select + $3C0;
      for Vtx := 0 to 31 do
      Begin
           NameTadr := Name_Table_Select;
           Vtx2 := 0;
           for Vty := Sct to 31 do
           Begin
                VTable[Vtx,Vtx2] := PPUMem[Vty shl 5 + Vtx + NameTadr];
                Inc(Vtx2);
           End;
           If Name_Table_Select = $2000 Then
              NameTadr:= $2800
           ELSE NameTadr:= $2000;
           for Vty := 0 to Sct do
           Begin
                VTable[Vtx,Vtx2] := PPUMem[Vty shl 5 + Vtx + NameTadr];
                Inc(Vtx2);
           End;
      End;
 End;
 Inc(AttAdr, StartA);
 NameTadr := Name_Table_Select;
 for tiley := 0 to 5 do Begin
  for tilex := 0 to 7 do Begin
   pByte1 := PPUMem[AttAdr];
   Inc(AttAdr);
   If AttAdr >= $2400 Then Attadr := $27C0;
   Tx2 := 0;
   for tiley2 := (tiley shl 2) to (tiley shl 2) + 3 do Begin
    for tilex2 := (tilex shl 2) to (tilex shl 2) + 3 do Begin
     ucolor := 0;
     If pByte1 and (1 shl Tx2) <> 0 Then Inc(ucolor, 4);
     If pByte1 and (1 shl (Tx2+1)) <> 0 Then Inc(ucolor, 8);
     Inc(Tx2,2);
     for tiley3 := tiley2 to tiley2+1 do Begin
      for tilex3 := tilex2 to tilex2+1 do Begin
       tilet := VTable[tilex3, tiley3];
       ScreenAdr := (tilet shl 4) + Scr_Pat_Tab_Adr - 1;
       for Ty := 0 to 7 do Begin
        pByte3 := PPUMem[ScreenAdr];
        pByte4 := PPUMem[ScreenAdr+8];
        Inc(ScreenAdr);
        for Tx := 0 to 7 do Begin
         color := ucolor;
         If pByte3 and (1 shl (7-Tx)) <> 0 Then Inc(color, 1);
         If pByte4 and (1 shl (7-Tx)) <> 0 Then Inc(color, 2);
         ASM
          mov es, Page1
          mov al, tiley3
          shl al, 3
          add al, Ty
          shl ax, 8
          mov di, ax
          shr ax, 2
          add di, ax
          mov cl, tilex3
          shl cl, 3
          add cl, Tx
          sub cl, Sc
          add di, cx
          mov al, color
          mov es:[di], al
         End;
        End;
       End;
      End;
     End;
     Inc(tilex2);
    End;
    Inc(tiley2);
   End;
  End;
 End;
{End;}
End;

PROCEDURE DrawSprites1;
VAR
 Sprite : byte;
 SpriteAdr : byte;
 SprX,                  { Sprite X-Pos @ Left Side }
 SprY,                  { Sprite Y-Pos @ Top Side }
 SprP,                  { Sprite Pattern Number }
 SprData : byte;        { Sprite Data Byte }
 Vflip,Hflip : boolean;
 ucolor, color : byte;
 ScreenAdr : word;
 pByte3, pByte4 : byte;
 Tx,                     { ? }
 Ty : byte;              { ? }
 Temp : Byte;
 i : shortint;
 Tyi,Txi : shortint;
Begin
     If Spr_Disp Then
     Begin
{DirectVideo := False;
GotoXY(1,1);}
          For Sprite := 0 to 63 Do
          Begin
               SpriteAdr := Sprite shl 2;      { Sprite Data = 4 Bytes Long }
               UColor := 0;
               SprY    := SprRAM[SpriteAdr];
               SprP    := SprRAM[SpriteAdr+1];
               SprData := SprRAM[SpriteAdr+2];
               SprX    := SprRAM[SpriteAdr+3];
{If (SprY < 240) Then
   WriteLn(Sprite,'-',Hex(SprP),'-',Hex(SprData),' = ',SprX,',',SprY);}

{               DirectVideo := False; GotoXY(1,1);
               WriteLn(SprX:3,',',SprY:3);
               WriteLn(SprData AND $04 Shr 2,'-',SprData AND $08 Shr 3,'-',SprData AND $10 Shr 4);
               WriteLn('Sprite Behind Back : ',SprData AND $20 shr 5);
               WriteLn('Flip Sprite Horiz  : ',SprData AND $40 shr 6);
               WriteLn('Flip Sprite Vert   : ',SprData AND $80 shr 7);
               For Temp := 0 to 7 Do
                   Mem[$A000:SprY*320+SprX+Temp] := 200;
               If SprData AND $20 = 0 Then Delay(500);
}
               If (SprData AND $80) <> 0 Then VFlip := True ELSE VFlip := False;
               If (SprData AND $40) <> 0 Then HFlip := True ELSE HFlip := False;
               UColor := 16;
               { Set Upper 2 bits of Color }
               UColor := UColor + ((SprData AND 2) shl 2) + (SprData AND 1) shl 2;
{
  For i := 0 to 17 Do
  Begin
       ScreenAdr := (i*32 shl 4) + (Spr_Pat_Tab_Adr)-1;
       For Tx := 0 to 31 Do
           For Ty := 0 to 7 Do
               For Temp := 0 to 7 Do
               Begin
                    Color := UColor+
                             ((PPUMem[ScreenAdr+Ty+Tx*16]   AND (1 shl Temp)) shr Temp)+
                             ((PPUMem[ScreenAdr+Ty+Tx*16+8] AND (1 shl Temp)) shr Temp) shl 1;
                    Mem[$A000:(Ty+i*8)*320+7-Temp+Tx*8] := Color;
               End;
  End;
}

               ScreenAdr := (SprP shl 4) + (Spr_Pat_Tab_Adr)-1;
               If ((SprX > 8) AND (Spr_Clip)) AND (SprX <= 256) AND (SprY < 240) Then
                  For Ty := 0 to 7 Do
                  Begin
                       For Temp := 0 to 7 Do
                       Begin
                            Color := UColor+
                                     ((PPUMem[ScreenAdr]   AND (1 shl Temp)) shr Temp)+
                                     ((PPUMem[ScreenAdr+8] AND (1 shl Temp)) shr Temp) shl 1;
                            If Color <> UColor Then
                               Mem[Page1:(SprY+7-Ty)*320+SprX+7-Temp] := Color;
{                               If (Not(HFlip)) AND (Not(VFlip)) Then
                                  Mem[Page1:(SprY+7-Ty)*320+SprX+7-Temp] := Color
                               ELSE If (HFlip) AND (VFlip) Then
                                  Mem[Page1:(SprY+Ty)*320+SprX+Temp] := Color
                               ELSE If (HFlip) AND (Not(VFLip)) Then
                                  Mem[Page1:(SprY+Ty)*320+SprX+7-Temp] := Color
                               ELSE If (Not(HFlip)) AND (VFlip) Then
                                  Mem[Page1:(SprY+7-Ty)*320+SprX+Temp] := Color;}
                       End;
                       Inc(ScreenAdr);
                  End;
(*
               If SprY < 245 Then
                  If (SprX<>0) OR (SprY<>0) Then
                  Begin
                       If (SprX > 8) and (Spr_Clip) Then
                       Begin
                            for i := 0 to Sprite_Size do
                            Begin
                                 If i <> 0 Then    { Used for 8x16 Sprites }
                                    ASM Ror Si, 1 End;
              {ScreenAdr := (Pattern * 16) + (Spr_Pat_Tab_Adr)-1;}
                                 ScreenAdr := (SprP shl 4) + (Spr_Pat_Tab_Adr)-1;
                                 Ty := 0{Byte(VFlip)*9};
{                                 Tyy := i shl 3;}
                                 Repeat
                                       pByte3 := PPUMem[ScreenAdr];
                                       pByte4 := PPUMem[ScreenAdr+8];
                                       Inc(ScreenAdr);
                                       Tx := 0{Byte(HFlip)*9};
{                                       Txx := 0;}
                                       repeat
{                                             Inc(Txx);}
                                             color := ucolor;
                                             If pByte3 and (1 shl (8-Tx)) <> 0 Then Inc(color, 1);
                                             If pByte4 and (1 shl (8-Tx)) <> 0 Then Inc(color, 2);
               If Color <> UColor Then
                  Mem[Page1:(SprY+Ty{+Tyy})*320+SprX+Tx] := Color;
{                                             ASM
                                                mov al, color
                                                cmp al, ucolor
                                                je @skipP
                                                mov es, Page1
                                                mov al, Sy
                                                add al, Ty
                                                add al, Tyy
                                                shl ax, 8
                                                mov di, ax
                                                shr ax, 2
                                                add di, ax
                                                mov cl, Sx
                                                add cl, Txx
                                                add di, cx
                                                mov al, color
                                                mov es:[di], al
                                               @skipP:
                                             End;}
                                             Tx := Tx + 1{Byte(HFlip)*-2 +1};
                                       Until (Tx = 9);
                                       Ty := Ty + 1{Byte(VFlip)*-2 +1};
                                 Until (Ty = 9);
                            End;
                       End;
                  End;
*)
          End;
     End;
{     Delay(50);}
End;

PROCEDURE DumpPal; assembler;
ASM
 mov es, Page1
 xor di, di
 mov al, 0
 mov cl, 16
@ImagePal:
  push cx
 mov cx, 4
@ImagePal2:
 mov es:[di], al
  push di
 add di, 4
 add al, 16
 mov es:[di], al
 sub al, 16
  pop di
 inc di
 dec cx
 loopnz @ImagePal2
  pop cx
 sub di, 2
 add di, 320
 inc al
 dec cl
 loopnz @ImagePal
End;


PROCEDURE WaitRetrace; Assembler;
ASM
    Mov dx,3DAh
@l1:
    In al,dx
    And al,08h
    Jnz @l1
@l2:
    In al,dx
    And al,08h
    Jz  @l2
END;

PROCEDURE DoPals;
VAR i : byte;
Temp : Byte;
Begin
{     WaitRetrace;   (**** Slow!!!! ****)
}     If (OldBGColor <> BGColor) Then
     Begin
          Port[$3C8] := 0;
          If BGcolor = 1 Then Port[$3C9] := 60 ELSE Port[$3C9] := 0;
          If BGcolor = 2 Then Port[$3C9] := 60 ELSE Port[$3C9] := 0;
          If BGcolor = 4 Then Port[$3C9] := 60 ELSE Port[$3C9] := 0;
          OldBGColor := BGColor;
     End;
(*
     ASM                         {Timing on 486}
        Xor Al, Al                  {(01)                                   }
        Mov Dx, $3C8                {(01)                                   }
        Out Dx, Al                  {(16)                                   }

        Lea Di, PPUMem              {(01) DI = Offset(PPUMem[$0000])        }
        Add Di, $3F00               {(01) DI = Offset(PPUMem[$3F00])            }

        Lea Si, Pal                 {(01) SI = Offset(Pal[$3F00])           }
        Inc Dx                      {(01) DX = $3C9                         }
        Xor Bx, Bx                  {(01) BX = 0                            }
        Xor Ax, Ax                  {(01) AX = 0                            }
       @PalLoop:
        Mov Cl, Ds:[Di+Bx]          {(01) CL = PPUMem[$3F00+i]              }
        XChg Bx, Cx                 {(03) BL = PPUMem[$3F00+i], CL = i      }
        Mov Al, Bl                  {(01) Al = Bl                           }
        Shl Bl, 1                   {(03) Bl = Bl * 2                       }
        Add Bl, Al                  {(01) Bl = Bl * 2 + Bl = Bl * 3        }

        Mov Al, Ds:[Si+Bx+0]        {(01) AL = Pal[PPUMem[$3F00+i],1]       }
        Shr Al, 2                   {(03) AL = Pal[PPUMem[$3F00+i],1] SHR 2 }
        Out Dx, Al                  {(16) Port[$3C9] := AL                  }

        Mov Al, Ds:[Si+Bx+1]        {(01) AL = Pal[PPUMem[$3F00+i],2]       }
        Shr Al, 2                   {(03) AL = Pal[PPUMem[$3F00+i],2] SHR 2 }
        Out Dx, Al                  {(16) Port[$3C9] := AL                  }

        Mov Al, Ds:[Si+Bx+2]        {(01) AL = Pal[PPUMem[$3F00+i],3]       }
        Shr Al, 2                   {(03) AL = Pal[PPUMem[$3F00+i],3] SHR 2 }
        Out Dx, Al                  {(16) Port[$3C9] := AL                  }
        XChg Bx, Cx                 {(03)                                   }
        Inc Bx                      {(01) CX = CX + 1                       }
        Cmp Bx, $10                 {(01)                                   }
        Jnz @PalLoop                {(03 JMP/01 NJMP)                       }
     END;
*)
     Port[$3C8] := 0;
     For i := $0 To $F Do
         Begin
              Temp := PPUMem[$3F00+i];
              Port[$3C9] := Pal[Temp, 1] shr 2;
              Port[$3C9] := Pal[Temp, 2] shr 2;
              Port[$3C9] := Pal[Temp, 3] shr 2;
         End;
     For i := $0 To $F do
         Begin
              Port[$3C9] := Pal[PPUMem[$3F10+i], 1] shr 2;
              Port[$3C9] := Pal[PPUMem[$3F10+i], 2] shr 2;
              Port[$3C9] := Pal[PPUMem[$3F10+i], 3] shr 2;
         End;
End;

PROCEDURE ExecPPU0;
VAR
 i : byte;
Begin
 If Scr_Disp Then
    Begin
{         FillChar(Mem[Page1:0000],256*256-1,1);}
         DoPals;
         DrawTable0;
         DrawSprites0;
         If Menu.MainView Then DoMenu(Page1);
    End
 ELSE
    Begin
         FillChar(Mem[Page1:0],64000,0);
         If Menu.MainView Then DoMenu(Page1);
         Key := $FFFF;
    End;
 CopyPage(Page1,Page0);
 {DumpVRAM;}
 {DumpSprRam;}
End;

PROCEDURE ExecPPU1;
VAR
 i : byte;
 i2 : byte;
Begin
 DoPals;
 DrawTable1;
 DrawSprites1;
 If Scr_Disp Then CopyPage(Page1,Page0) ELSE FillChar(Mem[Page0:0],64000,0);
{ If Scr_Disp Then CopyPage(Page1,Page0) ELSE FillChar(Mem[Page0:0],64000,0);}
 {DumpVRAM;}
 {DumpSprRam;}
 {DumpPal;}
End;

PROCEDURE DoReset;
Begin
     Reset6502;
     OldBGColor := $FF;
     TimerTicks := CPUcPVB;
     NewROM := True;
End;

PROCEDURE DrawBox(X1, Y1, X2, Y2 : Integer; Color1, Color2, Method : Byte; Where : Word);
Begin
     FillRectangle(X1   ,Y1   ,X2   ,Y2   ,Color1,Color2, Method, Where);
     FillRectangle(X1+01,Y1+01,X2-01,Y1+11,Color2,Color1-1, Method, Where);
     FillRectangle(X2-10,Y1+02,X2-02,Y1+10,128   ,127   , Method, Where);
     WriteText(X2-9,Y1+03,129,'X',1,0,Where);
End;

PROCEDURE LoadROM;
TYPE
    FileInfo = record
       Name      : String;
       ShortName : String[13];
       Next      : Pointer;
    End;

VAR Mx, My    : Word;
    Mb        : Byte;
    TempX,
    TempY     : Word;
    ROMName   : String;
    DirInfo   : SearchRec;
    LDirInfo  : TFindData;
    Handle    : Word;
    FileCount : Word;
    DirCount  : Word;
    Selection : Word;
    Selection2: Word;
    FFirst    : ^FileInfo;
    DFirst    : ^FileInfo;
    Last      : ^FileInfo;
    Current   : ^FileInfo;
    Label Top;
Begin
  Top:
     DrawBox(LoadStart.X+000,LoadStart.Y+000,
             LoadStart.X+228,LoadStart.Y+190,132,130,0,Page1);

     WriteText (LoadStart.X+3,LoadStart.Y+3,132,'SELECT ROM TO LOAD',1,0,Page1);
     If Length(ROMDir) < 28 Then
        WriteText (LoadStart.X+005,LoadStart.Y+014,129,ROMDir,1,0,Page1)
     ELSE
        WriteText (LoadStart.X+005,LoadStart.Y+014,129,ROMDir,1,1,Page1);

     FillRectangle(LoadStart.X+003,LoadStart.Y+024,
                   LoadStart.X+156,LoadStart.Y+170,132,127,0,Page1);
     FillRectangle(LoadStart.X+156,LoadStart.Y+024,
                   LoadStart.X+224,LoadStart.Y+170,132,127,0,Page1);

     FillRectangle(LoadStart.X+003,LoadStart.Y+172,
                   LoadStart.X+224,LoadStart.Y+188,129,132,0,Page1);
     WriteText    (LoadStart.X+085,LoadStart.Y+177,127,'Load ROM',1,0,Page1);

     (* Find Directories *)
     DirCount := 0;
     New(DFirst);
     FindFirst(ROMDir+'*.*',Directory,DirInfo);
     If DirInfo.Name = '.' Then FindNext(DirInfo);
     If DosError = 0 Then
     While DosError = 0 Do
     Begin
          If (DirInfo.Attr AND Directory) <> $00 Then
          Begin
               Inc(DirCount);
               If DirCount = 1 Then
               Begin
                    DFirst^.Name := DirInfo.Name;
                    DFirst^.ShortName := DirInfo.Name;
                    DFirst^.Next := Nil;
                    Last := Addr(DFirst^);
               End
               ELSE
               Begin
                    New(Current);
                    Last^.Next := Current;
                    Current^.Name := DirInfo.Name;
                    Current^.ShortName := DirInfo.Name;
                    Current^.Next := Nil;
                    Last := Last^.Next;
               End;
          End;
          FindNext(DirInfo);
     End
     ELSE DFirst := Nil;

     (* Display Directories *)
     DirCount := 0;
     Current := Addr(DFirst^);
     While (Current <> Nil) AND (DirCount < 18) Do
     Begin
           If Length(Current^.Name) <= 8 Then
              WriteText (LoadStart.X+160,LoadStart.Y+026+DirCount*8,129,Current^.Name,1,0,Page1)
           ELSE
              WriteText (LoadStart.X+160,LoadStart.Y+026+DirCount*8,129,Current^.Name,1,1,Page1);
           Inc(DirCount);
           Current := Current^.Next;
     End;

(*
     DirCount := 0;
     FindFirst(ROMDir+'*.*',Directory,DirInfo);
     While DosError = 0 Do
     Begin
          If ((DirInfo.Attr AND Directory) > $00) AND (DirInfo.Name <> '.') Then
          Begin
               WriteText (LoadStart.X+160,LoadStart.Y+026+DirCount*8,129,DirInfo.Name,1,0,Page1);
               Inc(DirCount);
               If DirCount >= 18 Then Break;
          End;
          FindNext(DirInfo);
     End;
*)

     (* Find Files *)
     FileCount := 0;
     Handle := LFindFirst(ROMDir+'*.NES',NoAttribs,NOT(Directory),LDirInfo);
     New(FFirst);
     If Handle <> $FFFF Then
     Begin
          FFirst^.Name := LDirInfo.Name;
          FFirst^.ShortName := LDirInfo.ShortName;
          FFirst^.Next := Nil;
          Last := Addr(FFirst^);
          FileCount := 1;
          While LFindNext(Handle, LDirInfo) = 0 Do
          Begin
               Inc(FileCount);
               New(Current);
               Last^.Next := Current;
               Current^.Name := LDirInfo.Name;
               Current^.ShortName := LDirInfo.ShortName;
               Current^.Next := Nil;
               Last := Last^.Next;
          End;
          LFindClose(Handle);
     End
     ELSE
     Begin
       FindFirst('*.NES',Not(Directory),DirInfo);
       FFirst^.Next := Nil;
       If DosError = 0 Then
       Begin
         FFirst^.Name := DirInfo.Name;
         FFirst^.ShortName := DirInfo.Name;
         Last := Addr(FFirst^);
         While DosError = 0 Do
         Begin
            If (DirInfo.Attr AND Directory) = $00 Then
            Begin
                 Inc(FileCount);
                 New(Current);
                 Last^.Next := Current;
                 Current^.Name := DirInfo.Name;
                 Current^.ShortName := DirInfo.Name;
                 Current^.Next := Nil;
                 Last := Last^.Next;
            End;
         FindNext(DirInfo);
         End;
       End
       ELSE FFirst := Nil;
     End;

     (* Sort Files Alphabetically \/-HERE-\/ *)

     (* Display Files *)
     FileCount := 0;
     Current := Addr(FFirst^);
     While (Current <> Nil) AND (FileCount < 18) Do
     Begin
           ROMName := Copy(Current^.Name,1,Length(Current^.Name)-4);
           ROMName := Current^.Name;
           If Length(ROMName) < 20 Then
              WriteText (LoadStart.X+005,LoadStart.Y+026+FileCount*8,129,ROMName,1,0,Page1)
           ELSE
              WriteText (LoadStart.X+005,LoadStart.Y+026+FileCount*8,129,ROMName,1,1,Page1);
           Inc(FileCount);
           Current := Current^.Next;
     End;

     Selection := 0;
     Repeat
           CopyPage(Page1,Page2);

           For TempY := 0 to 8 Do
             For TempX := 0 to 151 Do
               Mem[Page2:TempX+LoadStart.X+004+(TempY+Selection*8+LoadStart.Y+025)*ScrWidth] :=
               Mem[Page2:TempX+LoadStart.X+004+(TempY+Selection*8+LoadStart.Y+025)*ScrWidth] XOR $FF;

           Key := GetKey($FFFF);
           Case Key Of
        {Up} $48E0 : If Selection > 0 Then Dec(Selection)
                        ELSE Selection := 0;
      {Down} $50E0 : If Selection < FileCount-1 Then Inc(Selection)
                        ELSE Selection := FileCount-1;
      {Left} $4BE0 : ;
     {Right} $4DE0 : ;
           End;

           Mb := 0;
           If MouseInstalled Then
           Begin
           ASM
              Mov Ax, $0003
              Int $33
              Mov Mb, Bl
              Mov Mx, Cx
              Mov My, Dx
              Push Dx
              Push Cx
           END;

           If MB > 0 Then
           Begin
                If (Mx > LoadStart.X+003) AND (Mx < LoadStart.X+156) AND
                   (My > LoadStart.Y+024) AND (My < LoadStart.Y+170) Then
                   Selection := (My-LoadStart.Y-026) DIV 8;
                If (Mx > LoadStart.X+156) AND (Mx < LoadStart.X+224) AND
                   (My > LoadStart.Y+024) AND (My < LoadStart.Y+170) Then
                   Begin
                        Selection2 := (My-LoadStart.Y-026) DIV 8;

                        If Selection2 < DirCount Then
                        Begin
                             DirCount := 0;
                             Current := Addr(DFirst^);
                             While (DirCount < Selection2) Do
                             Begin
                                  Last := Addr(Current^);
                                  Current := Current^.Next;
                                  Inc(DirCount);
                             End;
                             If Current^.Name[1] <> '.' Then
                                ROMDir := ROMDir + Current^.Name + '\'
                             ELSE If Current^.Name = '..' Then
                                Repeat
                                      Dec(ROMDir[0]);
                                Until ROMDir[Length(ROMDir)] = '\';
                        End;

                        Current := Addr(DFirst^);
                        While Current <> Nil Do
                        Begin
                             Last := Addr(Current^);
                             Current := Current^.Next;
                             Dispose(Last);
                        End;

                        Current := Addr(FFirst^);
                        While Current <> Nil Do
                        Begin
                             Last := Addr(Current^);
                             Current := Current^.Next;
                             Dispose(Last);
                        End;
                        Delay(200);
                        goto Top;
                   End;
                If (My >= LoadStart.Y+172) AND (My <= LoadStart.Y+188) AND
                   (Mx >= LoadStart.X+003) AND (Mx <= LoadStart.X+224) Then
                   Key := $1C0D;
                If (Mx > LoadStart.X+218) AND (Mx < LoadStart.X+226) AND
                   (My > LoadStart.Y+002) AND (My < LoadStart.Y+012) Then
                   Key := $011B
           End;

           (** Draw Mouse **)
           For TempY := 0 to 11 Do
             For TempX := 0 to 11 Do
               If (Mx+TempX < ScrWidth) AND (My+TempY < ScrHeight) AND
                  (MouseCur[TempY,TempX] <> $FF) Then
                  Mem[Page2:Mx+TempX+(My+TempY)*ScrWidth] := MouseCur[TempY,TempX]+200;
           End;

           CopyPage(Page2,VGA);

     Until (Hi(Key) = $01) or (Lo(Key) = $0D);
     If (Lo(Key) = $0D) Then
     Begin
          Current := Addr(FFirst^);
          For TempX := 1 to Selection Do
              Current := Current^.Next;

          ROMName := Current^.ShortName;
          If LoadNES(ROMDir+ROMName,False) <> 0 Then
          Begin
               WriteText(0,ScrHeight-9,129,'Cannot Load '+ROMName+'.NES',1,0,Page0);
               Delay(1000);
          End
          ELSE DoReset;
     End;

     Current := Addr(DFirst^);
     While Current <> Nil Do
     Begin
          Last := Addr(Current^);
          Current := Current^.Next;
          Dispose(Last);
     End;

     Current := Addr(FFirst^);
     While Current <> Nil Do
     Begin
          Last := Addr(Current^);
          Current := Current^.Next;
          Dispose(Last);
     End;
End;

(*
PROCEDURE LoadROM;
VAR
   ROMName : String;
Begin
     SetMode($03);
     Write('Enter ROM Name : ');
     ReadLn(ROMName);
     If (ROMName <> '') AND (LoadNES(ROMDir+ROMName+'.NES') = 0) Then
     Begin
          WriteLn('Reseting CPU...');
          WriteLn(' -Reading Reset Vector = $FFFE...');
          DoReset;
          WriteLn(' -Program Counter Reset to ', Hex(PC));
          WriteLn('Press any key to Begin emulation...');
          Readkey;
     End;
     DoScreenMode(ScreenMode);
     SetColor(127, 0, 0, 0);
     SetColor(128,28,28,28);
     SetColor(129,63,63,63);
     For NewX := 0 to 15 Do CopyColor(NewX,NewX+200);
End;
*)

PROCEDURE DoExit;
Begin
     SetMode($3);
     WriteLn;
     {Writeln('Executed ',CPUticks,' CPU ticks.');
     Writeln('Executed ',CPUinstr,' Instructions.');}
     ShutDown;
     WriteLn('NEZulator ',Ver,' finished Okay!');
 Repeat
       Key := GetKey(Key);
       GotoXY(1,4); WriteLn('Hit "ESC" to end');
       WriteLn('Key = ',Hex(Key):5);
 Until Hi(Key) = $01;
     Halt;
End;


(* Menu choices are entered here *)
PROCEDURE DoMenuItems(Selection : Byte);
Begin
     Case Selection Of
    { $xy : x=column, y = row }
     (* File *)
      $01 : LoadROM;
      $03 : DoExit;
     (* CPU *)
      $11 : DoReset;
     (* Sound *)
      $21 : ;
     (* Graphics *)
      $31 : ;
     (* Misc *)
      $41 : ;
     End;
End;

PROCEDURE DoMenu(Where : Word);
VAR Mx, My : Word;
    Mb : Byte;
    TempX, TempY : Word;
    NMx, NMy : Word;
Begin
     (**** Make the screen greyed-out ****)
     For TempY := 0 to 240 Do
         For TempX := 0 to ScrWidth-1 Do
             If (TempX + TempY) MOD 2 = 1 Then
                Mem[Where:TempX + (TempY * ScrWidth)] := 199;
     (******************************)

     WriteText(ScrWidth DIV 2-7*8+1,ScrHeight-14,127,'NEZulator v'+Ver,1,0,Where);
     WriteText(ScrWidth DIV 2-7*8  ,ScrHeight-15,129,'NEZulator v'+Ver,1,0,Where);

     FillRectangle(0,0,ScrWidth-1,15,129,127,0,Where);
     For TempX := 0 to 4 Do
     Begin
          If Length(MenuItems[TempX,0].Name) <= 6 Then
             WriteText(2+50*TempX,4,129,MenuItems[TempX,0].Name,1,0,Where)
          ELSE
             WriteText(2+50*TempX,4,129,MenuItems[TempX,0].Name,1,1,Where);
          VLine(1,15,50*(TempX+1),129,0,Where);
     End;

     Mb := 0;
     If MouseInstalled Then
     ASM
        Mov Ax, $0003
        Int $33
        Mov Mb, Bl
        Mov Mx, Cx
        Mov My, Dx
        Push Dx
        Push Cx
     END;

     If (Key <> $FFFF) Then
     Begin
             Case Key Of
         {F} $2100 : If Menu.Show = 1 Then Menu.Show := 0 ELSE Menu.Show := 1;
         {C} $2E00 : If Menu.Show = 2 Then Menu.Show := 0 ELSE Menu.Show := 2;
         {G} $2200 : If Menu.Show = 3 Then Menu.Show := 0 ELSE Menu.Show := 3;
         {S} $1F00 : If Menu.Show = 4 Then Menu.Show := 0 ELSE Menu.Show := 4;
         {M} $3200 : If Menu.Show = 5 Then Menu.Show := 0 ELSE Menu.Show := 5;
        {Up} $48E0 : If CurrentPos > 0 Then Dec(CurrentPos)
                        ELSE CurrentPos := MenuLength[Menu.Show-1];
      {Down} $50E0 : If Menu.Show = 0 Then Menu.Show := 1 ELSE
                     If CurrentPos < MenuLength[Menu.Show-1] Then Inc(CurrentPos)
                        ELSE CurrentPos := 0;
      {Left} $4BE0 : If Menu.Show > 1 Then Dec(Menu.Show) ELSE Menu.Show := 5;
     {Right} $4DE0 : If Menu.Show < 5 Then Inc(Menu.Show) ELSE Menu.Show := 1;
     {Enter} $1C0D : If Menu.Show = 0 Then Menu.Show := 1 ELSE MB := 1;
             End;
             If (Menu.Show >= 1) AND (CurrentPos > MenuLength[Menu.Show-1]) Then
                CurrentPos := MenuLength[Menu.Show-1];

          If Menu.Show > 0 Then
          Begin
               Mx := (Menu.Show - 1)  * 50 + 46;
               My := CurrentPos       * 11 + 11;
               If CurrentPos > MenuLength[Menu.Show-1] Then
                  MenuLength[Menu.Show-1] := CurrentPos;
          End;
     End;
     ASM
        Mov Ax, $0003
        Int $33
        Pop Ax
        Cmp Ax, Cx
        Je @NoXMove
        Mov Mx, Ax
       @NoXMove:
        Pop Ax
        Cmp Ax, Dx
        Je @NoYMove
        Mov My, Ax
       @NoYMove:
        Mov Ax, $0004
        Mov Cx, Mx
        Mov Dx, My
        Int $33
     END;
     NMx := Mx DIV 50;
     NMy := (My-5) DIV 11;

     If (Menu.Show > 0) Then
     Begin
          TempX := 0;
          For TempY := 11 downto 1 Do
          Begin
               If (MenuItems[Menu.Show-1,TempY].Visible) and (TempX = 0) Then
               Begin
                    TempX := TempY;
                    If 100+(Menu.Show-1)*50 < ScrWidth Then
                       FillRectangle(0+(Menu.Show-1)*50,15,100+(Menu.Show-1)*50,15+TempY*11,129,127,0,Where)
                    ELSE
                       FillRectangle(-50+(Menu.Show-1)*50,15,50+(Menu.Show-1)*50,15+TempY*11,129,127,0,Where);
               End;
               If TempX > 0 Then
               Begin
                    If 100+(Menu.Show-1)*50 < ScrWidth Then
                    Begin
                         If Length(MenuItems[Menu.Show-1,TempY].Name) <= 6 Then
                            WriteText(2+50*(Menu.Show-1),6+TempY*11,129-Byte(Not(MenuItems[Menu.Show-1,TempY].Visible)),
                                      MenuItems[Menu.Show-1,TempY].Name,1,0,Where)
                         ELSE
                            WriteText(2+50*(Menu.Show-1),6+TempY*11,129-Byte(Not(MenuItems[Menu.Show-1,TempY].Visible)),
                                      MenuItems[Menu.Show-1,TempY].Name,1,1,Where);
                    End
                    ELSE
                    Begin
                         If Length(MenuItems[Menu.Show-1,TempY].Name) <= 6 Then
                            WriteText(-48+50*(Menu.Show-1),6+TempY*11,129-Byte(Not(MenuItems[Menu.Show-1,TempY].Visible)),
                                      MenuItems[Menu.Show-1,TempY].Name,1,0,Where)
                         ELSE
                            WriteText(-48+50*(Menu.Show-1),6+TempY*11,129-Byte(Not(MenuItems[Menu.Show-1,TempY].Visible)),
                                      MenuItems[Menu.Show-1,TempY].Name,1,1,Where);
                    End
               End;
          End;

          { Because this is so long, we need to check the mouse Buttons }
          { again, because it gets missed quite a bit }
          If (MouseInstalled) and (MB = 0) Then
          ASM
             Mov Ax, $0003
             Int $33
             Mov Mb, Bl
          END;

          If (My > 15) AND (My <= 15+TempX*11) Then
          Begin
               If ((100+(Menu.Show-1)*50 < ScrWidth) and
                  (Mx >= (Menu.Show-1)*50) and
                  (Mx <= 100+(Menu.Show-1)*50)) Then
               Begin
                    For TempY := 0 to 9 Do
                      For TempX := (Menu.Show-1)*50+1 to (Menu.Show-1)*50+99 Do
                        Mem[Where:TempX+(TempY+NMy*11+5)*ScrWidth] :=
                        Mem[Where:TempX+(TempY+NMy*11+5)*ScrWidth] XOR $FF;
                    If (Mb > 0) Then
                       DoMenuItems((Menu.Show-1)*$10+NMy);
               End
               ELSE
               If ((100+(Menu.Show-1)*50 >= ScrWidth) and
                  (Mx >= -48+(Menu.Show-1)*50) and
                  (Mx <= 50+(Menu.Show-1)*50)) Then
               Begin
                    For TempY := 0 to 9 Do
                      For TempX := (Menu.Show-1)*50-49 to (Menu.Show-1)*50+49 Do
                        Mem[Where:TempX+(TempY+NMy*11+5)*ScrWidth] :=
                        Mem[Where:TempX+(TempY+NMy*11+5)*ScrWidth] XOR $FF;
                    If (Mb > 0) Then
                       DoMenuItems((Menu.Show-1)*$10+NMy);
               End;
          End;
     End;

     (** Hilight Menu **)
     If ((My <= 15) AND (Mx < 250)) Then
     Begin
          If Menu.Show > 0 Then Menu.Show := NMx+1;
             For TempY := 1 to 14 Do
               For TempX := NMx*50+1 to NMx*50+49 Do
                 Mem[Where:TempX+(TempY)*ScrWidth] :=
                 Mem[Where:TempX+(TempY)*ScrWidth] XOR $FF;
     End
     ELSE
     If Menu.Show > 0 Then
        For TempY := 1 to 14 Do
          For TempX := (Menu.Show-1)*50+1 to (Menu.Show-1)*50+49 Do
            Mem[Where:TempX+(TempY)*ScrWidth] :=
            Mem[Where:TempX+(TempY)*ScrWidth] XOR $FF;

     (** Draw Mouse **)
     For TempY := 0 to 11 Do
       For TempX := 0 to 11 Do
         If (Mx+TempX < ScrWidth) AND (My+TempY < ScrHeight) AND
            (MouseCur[TempY,TempX] <> $FF) Then
            Mem[Where:Mx+TempX+(My+TempY)*ScrWidth] := MouseCur[TempY,TempX]+200;

     If Counter > 0 Then Dec(Counter)
     ELSE If (My <= 15) AND (Mx < 250) Then
        Begin
             For TempX := 0 to 4 Do
                 If (Mx >= 50*TempX) AND (MX < 50*(TempX+1)) AND (Mb > 0) Then
                    Begin
                         If Menu.Show = TempX+1 Then Menu.Show := 0 ELSE
                            Menu.Show := TempX+1;
                         Counter := 16;
                         Break;
                    End;
        End
     ELSE If Mb > 0 Then Menu.Show := 0;
     Key := $FFFF;
End;

{/\/\/\/\Execute Instruction/\/\/\/\}
PROCEDURE Exec6502;
Begin
     Count := 0;
     Key := $FFFF; TimerTicks := CPUcPVB;
     Repeat
{           Inc(Count); Write(T,Count,',');
           If Count MOD(1024) = 0 Then
           Begin
                Close(T);
                rewrite(T);
           End;}
           OpCode := CPUMem^[PC];
           Inc(PC);
           Instruction[OpCode];
{$ifdef DEBUG2}
 WRITEOpCodeF;
 writeln(T,
         ' ($',Copy(Hex(OpCode),4,2),')',
         ' A:',RA,
         ' X:',Copy(Hex(RX),4,2),
         ' Y:',Copy(Hex(RY),4,2),
         ' S:',Copy(Hex(RS),4,2),
         ' PC:',Hex(PC),
         ' GI:',Copy(Hex(CPUMem^[SavePC]),4,2),
         ' sPC:',Hex(SavePC),
         ' VB:',Byte(VBlank),
         ' VBc:', VBlank_Clocks
        );
{$endif}
           Dec(TimerTicks, Ticks[OpCode]);   { # Of Clock Ticks/Instruction }
           Dec(TimerTicks, ClockTicks);             { For Extra Clock Ticks }
           PPUCheck;
           If (TimerTicks < 0) Then
           Begin
                Repeat
                      If Key = $FFFF Then       { 2000% faster then ReadKey }
                         Key := GetKey(Key);{ and detects ALT, CTRL, etc... }
                      If Key < $FFFF Then
                      Begin
                           Case Key Of
                            $011B : Begin
                                         Menu.MainView := Not(Menu.MainView);
                                         Key := $FFFF;
                                    End;
                            $2D00 : DoExit;
    {ALT-F3}                $6A00 : Begin
                                         Menu.MainView := Not(Menu.MainView);
                                         Menu.Show := 1;
                                         CurrentPos := 1;
                                         LoadROM;
                                    End;
                           End;
                      End;

                      If FrameSkip = 0 Then
                      Begin
                           Case ScreenMode Of
                            0,
                            2 : ExecPPU0;
                            1 : ExecPPU1;
                           End;
                      End;
                      Inc(FrameSkip);
                      FrameSkip := FrameSkip AND FramesSkip;
                Until (Menu.MainView = False) OR (NewROM);

                VBlank_Clocks := 8;
                VBlank := True;

                If NewROM Then
                   Begin
                        NewROM := False;
                        Key := $FFFF;
                        Menu.MainView := False;
                        Continue;
                   End;

                CPUMem^[$2002] := CPUMem^[$2002] OR $80;
                Inc(TimerTicks, CPUcPVB);
                If Exec_NMI_VBlank Then
                Begin
                     nmi6502;
  {$ifdef DEBUG}
   Writeln(T,'--NMI--');
  {$endif}
                End;
           End
           ELSE If (VBlank_Clocks <= 0) Then
           Begin
                If (VBlank) Then
                Begin
                     CPUMem^[$2002] := CPUMem^[$2002] AND $7F;
                     VBlank := False;
                End;
           End
           ELSE Dec(VBlank_Clocks,ClockTicks);
{PPUIO}
{           CPUMem^[$2007] := PPUMem[PPUADDR];}
           ClockTicks := 0;
     Until (1 = 2);
End;

FUNCTION LoadNES(FileName : String; ShowData : Boolean) : Byte;
CONST
     Mirror : Array[0..3] Of String = ('Horizontal','Vertical','4 Screen','4 Screen');
     NoYes  : Array[0..1] Of String = ('No','Yes');

TYPE
    NESHeader = record
     Header     : Array[0..2] Of Char;
     Escape     : Byte;
     PRGPages   : Byte;
     CHRPages   : Byte;
     ROMCtrl1   : Byte;
     ROMCtrl2   : Byte;
     Expansion  : Array[0..7] Of Char;
    END;
VAR
 NESHead : NESHEader;
 F : File;
Begin
 {$I-}
 Assign(F, FileName); Reset(F,1);
 If IOResult <> 0 Then
    Begin
         LoadNES := 2;
         Exit;
    End;   {    Error('ERROR: '+filename+' does not exist.');}
 {$I+}
 FillChar(CPUMem^[Help],$FFFF,0);
 BlockRead(F,NESHead,SizeOf(NESHEad));
 With NESHead Do
      Begin
           VertMirror := Boolean(ROMCtrl1 AND 1);
           MapperType := (ROMCtrl1 AND 240) SHR 8 + (ROMCtrl2 AND 240);
           If ShowData = True Then
           Begin
                WriteLn(' -Program Size    : ', PRGPages*16:3,' kb/', CHRPages*8:3,' kb');
                WriteLn(' -Mirroring Style : ', Mirror[ROMCtrl1 AND 1 + (ROMCtrl1 AND 8) DIV 4]);
                WriteLn(' -Battery Backup  : ', NoYes[(ROMCtrl1 AND 2) shr 1]);
                WriteLn(' -Game Trainer    : ', NoYes[ROMCtrl1 AND 4]);
                WriteLn(' -Mapper Type     : ', MapperType);
                If (ROMCtrl2 AND 15) <> 0 Then WriteLn('WARNING: Mapper # May be incorrect! Header contains garbage!');
                WriteLn(' -Expansion Data  : ', Expansion+#0);
           End;

           If (Header <> 'NES') Then
              Begin
                   Dispose(CPUMem);
                   Error(filename+' is bad.--'+header);
              End;

           If PRGpages = 1 Then Scart := True
              ELSE Scart := False;  {??}

           If PRGPages <= 4 Then BlockRead(F,CPUMem^[$8000],$4000*Word(PRGPages)+1)
              ELSE Error('Game Image Too Large for this Version!');

           If PRGpages = 1 Then Move(CPUMem^[$8000],CPUMem^[$C000],$4000);

           If CHRPages <= 2 Then BlockRead(F,PPUMem,$2000*Word(CHRPages)-1)
              ELSE Error('Game Image Too Large for this Version!');
      End;
 Close(F);
 LoadNES := 0;
 If MapperType > 16 Then
    If NESHEad.Expansion[0] <> #0 Then
       MapperType := MapperType AND 16;
 If MapperType = CNROM Then
 Begin
      Move(CPUMem^[$8000],PPUMem[0000],1024*8) {Copy first 8K of VROM to PPUMem[$0000:0000] }
 End;
End;

PROCEDURE ExecCONFIG(FileName : String);
VAR
 i : byte;
 Code : integer;
 s2 : string;
Begin
     Assign(T,'nez.cfg'); Reset(T);
     Repeat
           ReadLn(T, str);
           str := UpStr(str);
           If Pos(';', str) = 1 Then
           ELSE If Pos('SCREEN',str) <> 0 Then
              Begin
                   s2 := Copy(Str, Pos('=',Str)+1, length(Str));
                   val(s2,ScreenMode,code);
                   If Code <> 0 Then Error('Unknown Resolution Option: '+s2);
                   Case ScreenMode of
                     0: Writeln(' -Screen Mode: 256x256x256');
                     1: Writeln(' -Screen Mode: 320x200x256');
                     2: Writeln(' -Screen Mode: 256x240x256');
                     ELSE Writeln('Screen mode unknown. Using default: 256x256x256 mode');
                   End;
              End
           ELSE If Pos('JOYSTICK', Str) <> 0 Then
              Begin
                   s2 := Copy(Str, Pos('=',Str)+1, length(Str));
                   val(s2,JoyOF,code);
                   If Code <> 0 Then Error(' -Unknown Joystick Option: '+s2);
                   case JoyOF of
                    0: Writeln(' -Joystick is DISABLED');
                    1: Writeln(' -Joystick is ENABLED');
                    ELSE Writeln(' -Joystick mode unknown. Using default: DISABLED');
                   End;
              End
           ELSE If Pos('FRAMESKIP', Str) <> 0 Then
              Begin
                   s2 := Copy(Str, Pos('=',str)+1, length(Str));
                   val(s2,FramesSkip,code);
                   If Code <> 0 Then Error(' -Unknown Frameskip Option: '+s2);
                   Writeln(' -Frames to Skip: ',FramesSkip);
                   FramesSkip := 1 shl FramesSkip;
                   FrameSkip := FramesSkip shr 1;
                   While FrameSkip > 0 Do
                   Begin
                        FramesSkip := FramesSkip OR FrameSkip;
                        FrameSkip := FrameSkip shr 1;
                   End;
              End
           ELSE If Pos('ROMDIR', Str) <> 0 Then
              Begin
                   ROMDir := Copy(Str, Pos('=',str)+1, length(Str));
                   While ROMDir[1] = #32 Do ROMDir := Copy(ROMDir,2,Length(ROMDir)-1);
              End;
     Until EOF(T);
     Close(T);
End;

PROCEDURE CheckJoy;
Begin
     If JoyOF = 1 Then
        Begin
             Port[$201] := 0;               { Start Access of Joystick Read }
             Repeat
                   Joy := Port[$201];
                   If Joy and 1 <> 0 Then Inc(JoyX);
                   If Joy and 2 <> 0 Then Inc(JoyY);
                   If JoyX >= 25534 Then                { Give it some time }
                      Begin                             { before giving up. }
                           WriteLn('WARNING: No Joystick found!!');
                           JoyOF := 0;
                           Exit;
                      End;
             Until (Joy AND 1 = 0) and (Joy AND 2 = 0);
             JoyX := 0;
             JoyY := 0;
             ASM                {     We only need to read the PC }
                Mov Dx, $201    { joystick once for each of these }
                Xor Al, Al
                Out Dx, Al                 { Send a 0 to Joystick }
               @Again:
                In  Al, Dx                        { Read Joystick }
                Mov Bl, Al                           { Copy Value }
                Mov Cl, Al
                And Bl, $01         { Is Horiz Movment > 0 still? }
                Jz @CheckedJoyX
                Inc JoyX                 { If So, Then Inc(JoyX); }
               @CheckedJoyX:
                And Cl, $02          { Is Vert Movment > 0 still? }
                Jz @CheckedJoyY
                Inc JoyY                 { If So, Then Inc(JoyY); }
               @CheckedJoyY:
                And Al, $03  { Are both directions done counting? }
                Jnz @Again
             END;
             Jxc := JoyX;
             Jyc := JoyY;
             JoyX := 0;
             JoyY := 0;
        End;
End;

VAR
i:word;
t1,t2 : longint;

Begin
 Writeln;
 Writeln('      -=-The NEZulator-=-');
 Writeln('             v.0037');
 Writeln('  Updates/Addons by Troy McLeod');
 Writeln('     Originally by Jon Olick');
 Writeln('http://members.tripod.com/~nezulator');
 Writeln;
 Writeln('Allocating memory...');
 New(CPUMem);
 FillChar(CPUMem^,$FFFF,0);
 Writeln('Reading Configuration File');
 ExecCONFIG('nez.cfg');
 Writeln('Initializing CPU & Graphics...');
 Init6502;
 InitGraphics;                               (***************************)
 ClearPage(Page1);                           (***************************)
 ASM
    Mov Ax, $0000
    Int $33
    Mov MouseInstalled, Al
    jz @End
    Mov CurrentPos, 0
   @End:
 END;
 GetDir(0,OrigDir);
 If ROMDir[2] <> ':' Then
 Begin
      GetDir(0, Str);
      If Str[Length(Str)] <> '\' Then Str := Str + '\';
      If ROMDir[Length(ROMDir)] <> '\' Then ROMDir := ROMDir + '\';
      ROMDir := Str+ROMDir;
      {$I-}
      ChDir(ROMDir);
      While IOResult <> 0 Do
      Begin
           Repeat
                 Dec(ROMDir[0]);
           Until (ROMDir[Length(ROMDir)] = '\') or (ROMDir[0] = #0);
           ChDir(ROMDir);
      End;
      {$I+}
 End;
 ChDir(OrigDir);
 Writeln('Loading ',ROMDir+ParamStr(1),'...');
 LoadNES(ROMDir+ParamStr(1),True);
 {$ifdef DEBUG}
  assign(T, 'debug.nez');
  rewrite(T);
 {$endif}
 WriteLn('Reseting CPU...');
 DoReset;
 CheckJoy;
 While Key <> $FFFF Do Key := GetKey($FFFF);
 DoScreenMode(ScreenMode);
 SetColor(127, 0, 0, 0);
 SetColor(128,28,28,28);
 SetColor(129,63,63,63);
 SetColor(130, 0, 9,18);
 SetColor(131, 0,18,30);
 SetColor(132, 0,33,43);
 For NewX := 0 to 15 Do CopyColor(NewX,NewX+200);
 If ParamCount < 1 Then LoadROM;
 Exec6502;
end.
